﻿using System;

using System.Windows;  // MessageBox
using Microsoft.Win32;

using System.IO;
using System.Windows.Controls;

//using Word = Microsoft.Office.Interop.Word;

namespace Company {
    public class Basis {

        // Neu

        public static void setWindowPositionFromRegistry(Window dialog, String regadr, String title) {
            // 1:  ein Bildschirm nur PrimaryScreenWidth/PrimaryScreenHeight
            // 2:  zwei Bildschirme  VirtualScreenWidth  0 bis Width(1)+Width(2)
            // 3:  zwei Bildschirme  VirtualScreenWidth mit 0 bis Width(1)+Width(2)
            //             width ist aber   -Width(2) bis Width(1)
            int iTop = Basis.ReadRegInt(regadr, title + "_Top1");
            int iLeft = Basis.ReadRegInt(regadr, title + "_Left1");
            int iWidth = Basis.ReadRegInt(regadr, title + "_Width1");
            int iHeight = Basis.ReadRegInt(regadr, title + "_Height1");
            int w = (int)System.Windows.SystemParameters.PrimaryScreenWidth;
            int h = (int)System.Windows.SystemParameters.PrimaryScreenHeight;

            int virtualLeft = (int)System.Windows.SystemParameters.VirtualScreenLeft;
            int virtualW = (int)System.Windows.SystemParameters.VirtualScreenWidth;  // beide Breiten zusammen positiv
            int virtualH = (int)System.Windows.SystemParameters.VirtualScreenHeight;
            // iLeft kann negativ sein   und zwar  -SecondWidth
            if (iTop > 0 && (iTop - (iHeight >> 1) <= virtualH) && (iLeft >= virtualLeft) && (iLeft <= virtualLeft + virtualW) && iWidth > 50) {
                dialog.Top = iTop;
                dialog.Left = iLeft;
                dialog.Width = iWidth;
                dialog.Height = iHeight;
            }
            else {
                dialog.Top = 100;
                dialog.Left = 20;
            }
        }  // setWindowPositionFromRegistry

        public static void setWindowPositionFromRegistryWidthHeight(Window dialog, String regadr, String title) {
            // 1:  ein Bildschirm nur PrimaryScreenWidth/PrimaryScreenHeight
            // 2:  zwei Bildschirme  VirtualScreenWidth  0 bis Width(1)+Width(2)
            // 3:  zwei Bildschirme  VirtualScreenWidth mit 0 bis Width(1)+Width(2)
            //             width ist aber   -Width(2) bis Width(1)
            int iWidth = Basis.ReadRegInt(regadr, title + "_Width1");
            int iHeight = Basis.ReadRegInt(regadr, title + "_Height1");
            int w = (int)System.Windows.SystemParameters.PrimaryScreenWidth;
            int h = (int)System.Windows.SystemParameters.PrimaryScreenHeight;

            int virtualW = (int)System.Windows.SystemParameters.VirtualScreenWidth;  // beide Breiten zusammen positiv
            int virtualH = (int)System.Windows.SystemParameters.VirtualScreenHeight;
            // iLeft kann negativ sein   und zwar  -SecondWidth
            if (iWidth > 50) {
                dialog.Width = iWidth;
                dialog.Height = iHeight;
            }
            else {
                dialog.Top = 100;
                dialog.Left = 20;
            }
        }  // setWindowPositionFromRegistry



        public static void writeWindowPosition2Registry(Window dialog, String regadr, String title) {
            Basis.WriteRegInt(regadr, title + "_Top1", (int)dialog.Top);
            Basis.WriteRegInt(regadr, title + "_Left1", (int)dialog.Left);
            Basis.WriteRegInt(regadr, title + "_Width1", (int)dialog.Width);
            Basis.WriteRegInt(regadr, title + "_Height1", (int)dialog.Height);
        }  // writeWindowPosition2Registry


        /// <summary>
        /// Ausgabe des aktuellen Tags
        /// int tag = Basis.NowDay
        /// </summary>
        /// <returns></returns>
        public static int NowDay() {
            return System.DateTime.Now.Day;
        }

        /// <summary>
        /// Ausgabe des aktuellen Monats
        /// int monat = Basis.NowMonth
        /// </summary>
        /// <returns></returns>
        public static int NowMonth() {
            return System.DateTime.Now.Month;
        }
        /// <summary>
        /// Ausgabe des aktuellen Jahes
        /// int jahr = Basis.NowYear
        /// </summary>
        /// <returns></returns>
        public static int NowYear() {
            return System.DateTime.Now.Year;
        }
        /// <summary>
        /// Ausgabe des aktuellen Datum im Stringformat
        /// String s = Basis.NowDate()  // 01.02.2042
        /// </summary>
        /// <returns></returns>
        public static string NowDate() {
            return System.DateTime.Now.Day.ToString("00") + "." + System.DateTime.Now.Month.ToString("00") + "." + System.DateTime.Now.Year;
            //return 2012;
        }

        /// <summary>
        /// Ausgabe des aktuellen Datum im Stringformat fuer die backuproutine aus
        /// String s = Basis.getDatumBackup()  // 2042-02-01
        /// </summary>
        /// <returns></returns>
        public static String getDatumBackup() {
            return DateTime.Now.Year + "-" + DateTime.Now.Month.ToString("00") + "-" + DateTime.Now.Day.ToString("00");
        }

        /// <summary>
        /// Ausgabe die aktuelle Zeit im Stringformat fuer die backuproutine aus
        /// String s = Basis.getTimeBackup()  // 07-59
        /// </summary>
        /// <returns></returns>
        public static String getTimeBackup() {
            return DateTime.Now.Hour.ToString("00") + "-" + DateTime.Now.Minute.ToString("00");
        }


        /// <summary>
        /// Ersetzt die deutschen Umlaute in HTML Code, wird nicht benoetigt
        /// String s = Basis.UML("aä)  // a&#228;
        /// </summary>
        /// <param name="input"></param>
        /// <returns></returns>
        public static String UML(String input) {
            String output;
            if (input == null) return "";
            output = input.Replace("ä", "&#228;");
            output = output.Replace("ä", "&#228;");
            output = output.Replace("Ä", "&#196;");
            output = output.Replace("ö", "&#246;");
            output = output.Replace("Ö", "&#214;");
            output = output.Replace("ü", "&#252;");
            output = output.Replace("Ü", "&#220;");
            output = output.Replace("0", "&#223;");
            output = output.Replace(">", "&#62;");
            output = output.Replace("<", "&#60;");
            return output;
        }

        /// <summary>
        /// liefert den Programmpfad mit Backslash, z. B. fuer das Erstellen von Ordnern
        /// </summary>
        /// <returns></returns>
        public static String getProgPath() {
            string[] args = System.Environment.GetCommandLineArgs();
            String exepath = args[0];
            int i = exepath.LastIndexOf("\\");
            String path = exepath.Substring(0, i + 1);
            if (!path.EndsWith("\\")) path += "\\";
            return path;
        }

        /// <summary>
        /// Kapselt YesNoCancel
        /// MessageBoxResult result = Basis.readYesNoCancel("Platte formatieren","Virus");
        /// </summary>
        /// <param name="message"></param>
        /// <param name="title"></param>
        /// <returns></returns>
        public static MessageBoxResult readYesNoCancel(string message, string title) {
            return MessageBox.Show(message, title, MessageBoxButton.YesNoCancel, MessageBoxImage.Question);   // Exclamation
        }

        /// <summary>
        /// Kapselt YesNo
        /// bool result = Basis.readYesNo("Platte formatieren","Virus");
        /// </summary>
        /// <param name="message"></param>
        /// <param name="title"></param>
        /// <returns></returns>
        public static bool readYesNo(string message, string title) {
            return MessageBox.Show(message, title, MessageBoxButton.YesNo, MessageBoxImage.Question) == MessageBoxResult.Yes;
        }

        /// <summary>
        /// Kapselt die Ausgabe einer Meldung
        /// Basis.Message("Platte formatieren","Virus");
        /// </summary>
        /// <param name="message"></param>
        /// <param name="title"></param>
        /// <returns></returns>
        public static void Message(String text, String title) {
            MessageBox.Show(text, title, MessageBoxButton.OK, MessageBoxImage.Information);
        }

        /// <summary>
        /// Kapselt die Ausgabe einer Fehlermeldung
        /// Basis.ErrorMsg("Platte formatieren","Virus");
        /// </summary>
        /// <param name="text"></param>
        /// <param name="title"></param>
        public static void ErrorMsg(String text, String title) {
            MessageBox.Show(text, title, MessageBoxButton.OK, MessageBoxImage.Error);
        }


        /// <summary>
        /// Automatisches Anlegen der kompletten Pfade
        /// if (!Basis.createPath("c:\\daten\\test"))  Fehler
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public static bool createPath(String path) {
            try {
                Directory.CreateDirectory(path);
                return true;
            }
            catch {
                return false;
            }
        }



        /// <summary>
        /// DeleteBadFilenameChars loescht alle fehlerhaften Zeichen
        /// String filename=Basis.DeleteBadFilenameChars("abc:,.txt");
        /// </summary>
        /// <param name="input"></param>
        /// <returns></returns>
        public static string DeleteBadFilenameChars(String input) {
            String output;
            output = input.Replace(";", "");
            output = output.Replace(":", "");
            output = output.Replace(",", "");
            output = output.Replace("=", "");
            output = output.Replace("+", "");
            output = output.Replace("<", "");
            output = output.Replace(">", "");
            output = output.Replace("|", "");
            output = output.Replace("\"", "");
            output = output.Replace("/", "");
            output = output.Replace("\\", "");
            output = output.Replace("[", "");
            output = output.Replace("]", "");
            output = output.Replace("{", "");
            output = output.Replace("}", "");
            output = output.Replace("*", "");
            output = output.Replace("?", "");
            return output;
        }

        /// <summary>
        /// Prueft den Dateinamen auf fehlerhafte Zeichen
        /// </summary>
        /// <param name="filename"></param>
        /// <returns></returns>
        public static bool CheckFilename(String filename) {
            if (filename.Length == 0)
                return false;
            else {
                bool result = true;
                for (int i = 0; i < filename.Length; i++) {
                    String ch = filename.Substring(i, 1);
                    switch (ch) {
                        case "\\": result = false; break;
                        case "/": result = false; break;
                        case ":": result = false; break;
                        case "?": result = false; break;
                        case "*": result = false; break;
                        case "\"": result = false; break;
                        case "<": result = false; break;
                        case ">": result = false; break;
                        case "|": result = false; break;
                    }// case
                }// for
                return result;
            }// if
        }  //  pruefe_dateinamen 


        /// <summary>
        /// Trennt den vollen Dateinamen (Pfad+Name+Ext) in Pfad und Name.ext
        /// siehe auch splitFilename(String sPathFilename, out String path, out String name, out String ext) {
        /// </summary>
        /// <param name="pathFilename"></param>
        /// <param name="path"></param>
        /// <param name="filename"></param>
        public static void splitFilename(String pathFilename,
            out String path, out String filename) {
            int i = pathFilename.LastIndexOf("\\");
            if (i >= 0) {
                path = pathFilename.Substring(0, i + 1);
                filename = pathFilename.Substring(i + 1);
            }
            else {
                filename = pathFilename;
                path = "";
            }
        }

        /// <summary>
        /// split a filename into path, name and extention ( C:\\daten\\,  test1,  .asm )
        /// </summary>
        /// <param name="sPathFilename"></param>
        /// <param name="path"></param>
        /// <param name="name"></param>
        /// <param name="ext"></param>
        /// <returns></returns>
        public static void splitFilename(String sPathFilename,
            out String path, out String name, out String ext) {
            String filename = sPathFilename;
            int k = filename.LastIndexOf('\\');
            if (k >= 0) {
                path = filename.Substring(0, k + 1);
                filename = filename.Substring(k + 1);
            }
            else {
                path = "";
            }
            k = filename.LastIndexOf('.');
            if (k >= 0) {
                name = filename.Substring(0, k);
                ext = filename.Substring(k);  // .asm
            }
            else {
                name = filename;
                ext = "";
            }
        }  // splitFilename


        /// <summary>
        /// Bestimmt das Laufwerk mit dem letzten Ordner
        /// Beispiel:  c:\test\...\labor2
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public static String HeaderFolder(String path) {
            if (path.Length <= 3) {
                return path;
            }
            else {
                if (path.EndsWith("\\")) {
                    path = path.Substring(0, path.Length - 1);
                }
                int i = path.LastIndexOf("\\");
                if (i >= 0) {
                    string[] splitStrings = { "\\" };
                    String[] items = path.Split(splitStrings, StringSplitOptions.None);
                    if (items.Length <= 2)
                        return path;
                    else
                        return path.Substring(0, 3) + "..." + path.Substring(i + 1);
                }
                else {
                    return path;
                }
            }
        }

        /// <summary>
        /// liefert den letzten Ordner
        /// </summary>
        /// <param name="path"></param>
        /// <returns></returns>
        public static String getLastFolder(String path) {
            if (path.Length <= 3) {
                return path;
            }
            else {
                if (path.EndsWith("\\")) {
                    path = path.Substring(0, path.Length - 1);
                }
                int i = path.LastIndexOf("\\");
                if (i >= 0) {
                    return path.Substring(i + 1);
                }
                else {
                    return path;
                }
            }
        }

        /// <summary>
        /// leifert den kompletten Pfad OHNE Dateinamen
        /// </summary>
        /// <param name="filename"></param>
        /// <returns></returns>
        public static String getPath(String filename) {
            int i = filename.LastIndexOf("\\");
            if (i >= 0) {
                // String s = filename.Substring(0, i+1); 
                return filename.Substring(0, i + 1);
            }
            else {
                return "";
            }
        }


        /// <summary>
        /// return only the name and the extention, test.txt
        /// </summary>
        /// <param name="sPathFilename"></param>
        /// <returns></returns>
        public static String getFilename(String sPathFilename) {
            int k = sPathFilename.LastIndexOf('\\');
            if (k >= 0) {
                return sPathFilename.Substring(k + 1);
            }
            else {
                return sPathFilename;
            }
        }  // getFilename


        /*

        public static void export2Word(int fontsize, bool WeicheZeileabstaende, String text1) {
            String selection;
            String blackText;
            var word = new Word.Application();
            word.Visible = true;

            Word.Document doc = word.Documents.Add();
            word.Selection.Font.Name = "Courier New";
            word.Selection.Font.Size = fontsize;

            float rand127 = word.Application.CentimetersToPoints(1.27f);  // 36
            float rand200 = word.Application.CentimetersToPoints(2.00f);  // 36
            word.Selection.PageSetup.TopMargin = rand127;
            word.Selection.PageSetup.BottomMargin = rand127;
            word.Selection.PageSetup.LeftMargin = rand200;
            word.Selection.PageSetup.RightMargin = rand127;



            //    .TopMargin = CentimetersToPoints(1.27)
            String text = text1;
            String char11 = ((char)11).ToString();

            text = text.Replace("//b", "");
            text = text.Replace("b//", "");
            text = text.Replace("//r", "");
            text = text.Replace("r//", "");
            text = text.Replace("//f", "");
            text = text.Replace("f//", "");

            if (WeicheZeileabstaende) {
                text = text.Replace("\r\n", char11);
            }

            int nn = text.Length;
            if (text.IndexOf("//b") == -1 && text.IndexOf("//r") == -1 && text.IndexOf("//f") == -1) {
                word.Selection.TypeText(text);
            }
            else {
                int indexRed1, indexRed2;
                int indexBlue1, indexBlue2;
                indexRed1 = text.IndexOf("//r");
                indexBlue1 = text.IndexOf("//b");

                while (indexRed1 >= 0 || indexBlue1 >= 0) {
                    if (indexRed1 >= 0 && indexBlue1 >= 0) {
                        if (indexRed1 < indexBlue1) {
                            blackText = text.Substring(0, indexRed1);
                            word.Selection.TypeText(blackText);
                            indexRed2 = text.IndexOf("r//");
                            selection = text.Substring(indexRed1 + 3, indexRed2 - indexRed1 - 3);
                            word.Selection.Font.Color = Word.WdColor.wdColorRed;
                            word.Selection.Font.Bold = 1;
                            word.Selection.TypeText(selection);
                            word.Selection.Font.Color = Word.WdColor.wdColorBlack;
                            word.Selection.Font.Bold = 0;
                            text = text.Substring(indexRed2 + 3);
                        }
                        else {
                            blackText = text.Substring(0, indexBlue1);
                            word.Selection.TypeText(blackText);
                            indexBlue2 = text.IndexOf("b//");
                            selection = text.Substring(indexBlue1 + 3, indexBlue2 - indexBlue1 - 3);
                            word.Selection.Font.Color = Word.WdColor.wdColorBlue;
                            word.Selection.Font.Bold = 1;
                            word.Selection.TypeText(selection);
                            word.Selection.Font.Color = Word.WdColor.wdColorBlack;
                            word.Selection.Font.Bold = 0;
                            text = text.Substring(indexBlue2 + 3);
                        }
                    }
                    else {
                        if (indexBlue1 >= 0) {
                            blackText = text.Substring(0, indexBlue1);
                            word.Selection.TypeText(blackText);
                            indexBlue2 = text.IndexOf("b//");
                            selection = text.Substring(indexBlue1 + 3, indexBlue2 - indexBlue1 - 3);
                            word.Selection.Font.Color = Word.WdColor.wdColorBlue;
                            word.Selection.Font.Bold = 1;
                            word.Selection.TypeText(selection);
                            word.Selection.Font.Color = Word.WdColor.wdColorBlack;
                            word.Selection.Font.Bold = 0;
                            text = text.Substring(indexBlue2 + 3);
                        }
                        else {
                            if (indexRed1 >= 0) {
                                blackText = text.Substring(0, indexRed1);
                                word.Selection.TypeText(blackText);
                                indexRed2 = text.IndexOf("r//");
                                selection = text.Substring(indexRed1 + 3, indexRed2 - indexRed1 - 3);
                                word.Selection.Font.Color = Word.WdColor.wdColorRed;
                                word.Selection.Font.Bold = 1;
                                word.Selection.TypeText(selection);
                                word.Selection.Font.Color = Word.WdColor.wdColorBlack;
                                word.Selection.Font.Bold = 0;
                                text = text.Substring(indexRed2 + 3);
                            }
                            else {
                            }
                        }
                    }
                    indexRed1 = text.IndexOf("//r");
                    indexBlue1 = text.IndexOf("//b");
                }  // while

                int indexFett1 = text.IndexOf("//f");
                int indexFett2 = 0;
                while (indexFett1 >= 0) {
                    blackText = text.Substring(0, indexFett1);
                    word.Selection.TypeText(blackText);
                    indexFett2 = text.IndexOf("f//");
                    selection = text.Substring(indexFett1 + 3, indexFett2 - indexFett1 - 3);
                    //word.Selection.Font.Color = Word.WdColor.wdColorRed;
                    word.Selection.Font.Bold = 1;
                    word.Selection.TypeText(selection);
                    //word.Selection.Font.Color = Word.WdColor.wdColorBlack;
                    word.Selection.Font.Bold = 0;
                    text = text.Substring(indexFett2 + 3);
                    indexFett1 = text.IndexOf("//f");
                }
                word.Selection.TypeText(text);

            }
        }



        public static void export2Word(int fontsize, bool WeicheZeileabstaende, List<String> texte) {
            String selection;
            String blackText;
            var word = new Word.Application();
            word.Visible = true;

            Word.Document doc = word.Documents.Add();
            word.Selection.Font.Name = "Courier New";
            word.Selection.Font.Size = fontsize;

            float rand127 = word.Application.CentimetersToPoints(1.27f);  // 36
            float rand200 = word.Application.CentimetersToPoints(2.00f);  // 36
            word.Selection.PageSetup.TopMargin = rand127;
            word.Selection.PageSetup.BottomMargin = rand127;
            word.Selection.PageSetup.LeftMargin = rand200;
            word.Selection.PageSetup.RightMargin = rand127;



            //    .TopMargin = CentimetersToPoints(1.27)
            String char11 = ((char)11).ToString();  // \v
            String text = "";
            for (int i = 0; i < texte.Count; i++) {
                text = texte[i];
                if (WeicheZeileabstaende) {
                    text = text.Replace("\r\n", char11);
                }

                int nn = text.Length;
                if (text.IndexOf("//b") == -1 && text.IndexOf("//r") == -1 && text.IndexOf("//f") == -1) {
                    word.Selection.TypeText(text);
                }
                else {
                    int indexRed1, indexRed2;
                    int indexBlue1, indexBlue2;
                    indexRed1 = text.IndexOf("//r");
                    indexBlue1 = text.IndexOf("//b");

                    while (indexRed1 >= 0 || indexBlue1 >= 0) {
                        if (indexRed1 >= 0 && indexBlue1 >= 0) {
                            if (indexRed1 < indexBlue1) {
                                blackText = text.Substring(0, indexRed1);
                                word.Selection.TypeText(blackText);
                                indexRed2 = text.IndexOf("r//");
                                selection = text.Substring(indexRed1 + 3, indexRed2 - indexRed1 - 3);
                                word.Selection.Font.Color = Word.WdColor.wdColorRed;
                                word.Selection.Font.Bold = 1;
                                word.Selection.TypeText(selection);
                                word.Selection.Font.Color = Word.WdColor.wdColorBlack;
                                word.Selection.Font.Bold = 0;
                                text = text.Substring(indexRed2 + 3);
                            }
                            else {
                                blackText = text.Substring(0, indexBlue1);
                                word.Selection.TypeText(blackText);
                                indexBlue2 = text.IndexOf("b//");
                                selection = text.Substring(indexBlue1 + 3, indexBlue2 - indexBlue1 - 3);
                                word.Selection.Font.Color = Word.WdColor.wdColorBlue;
                                word.Selection.Font.Bold = 1;
                                word.Selection.TypeText(selection);
                                word.Selection.Font.Color = Word.WdColor.wdColorBlack;
                                word.Selection.Font.Bold = 0;
                                text = text.Substring(indexBlue2 + 3);
                            }
                        }
                        else {
                            if (indexBlue1 >= 0) {
                                blackText = text.Substring(0, indexBlue1);
                                word.Selection.TypeText(blackText);
                                indexBlue2 = text.IndexOf("b//");
                                selection = text.Substring(indexBlue1 + 3, indexBlue2 - indexBlue1 - 3);
                                word.Selection.Font.Color = Word.WdColor.wdColorBlue;
                                word.Selection.Font.Bold = 1;
                                word.Selection.TypeText(selection);
                                word.Selection.Font.Color = Word.WdColor.wdColorBlack;
                                word.Selection.Font.Bold = 0;
                                text = text.Substring(indexBlue2 + 3);
                            }
                            else {
                                if (indexRed1 >= 0) {
                                    blackText = text.Substring(0, indexRed1);
                                    word.Selection.TypeText(blackText);
                                    indexRed2 = text.IndexOf("r//");
                                    selection = text.Substring(indexRed1 + 3, indexRed2 - indexRed1 - 3);
                                    word.Selection.Font.Color = Word.WdColor.wdColorRed;
                                    word.Selection.Font.Bold = 1;
                                    word.Selection.TypeText(selection);
                                    word.Selection.Font.Color = Word.WdColor.wdColorBlack;
                                    word.Selection.Font.Bold = 0;
                                    text = text.Substring(indexRed2 + 3);
                                }
                                else {
                                }
                            }
                        }
                        indexRed1 = text.IndexOf("//r");
                        indexBlue1 = text.IndexOf("//b");
                    }  // while

                    int indexFett1 = text.IndexOf("//f");
                    int indexFett2 = 0;
                    while (indexFett1 >= 0) {
                        blackText = text.Substring(0, indexFett1);
                        word.Selection.TypeText(blackText);
                        indexFett2 = text.IndexOf("f//");
                        selection = text.Substring(indexFett1 + 3, indexFett2 - indexFett1 - 3);
                        //word.Selection.Font.Color = Word.WdColor.wdColorRed;
                        word.Selection.Font.Bold = 1;
                        word.Selection.TypeText(selection);
                        //word.Selection.Font.Color = Word.WdColor.wdColorBlack;
                        word.Selection.Font.Bold = 0;
                        text = text.Substring(indexFett2 + 3);
                        indexFett1 = text.IndexOf("//f");
                    }
                    word.Selection.TypeText(text);
                }
            }
        }
        */



        /// <summary>
        /// change the extension of a filename (c:\test.xml,  .xsd )
        /// </summary>
        /// <param name="filename"></param>
        /// <param name="extension"></param>
        public static String changeExtension(String filename, String extension ) {
            return System.IO.Path.ChangeExtension(filename, ".xsd");
        }

        /// <summary>
        /// einlesen eines String aus der Registry
        /// </summary>
        /// <param name="root"></param>
        /// <param name="KeyName"></param>
        /// <returns></returns>
        public static String ReadRegString(string root, string KeyName) {
            string sKey;
            RegistryKey regist;
            try {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return "";
                }
                else {
                    if (regist.GetValue(KeyName) == null)
                        sKey = "";
                    else {
                        sKey = regist.GetValue(KeyName).ToString();
                    }
                    return sKey;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                Basis.ErrorMsg(e.ToString(), "Writing registry " + KeyName.ToUpper());
                return "";
            }
        }  // readRegString

        /// <summary>
        /// einlesen eines Long aus der Registry
        /// </summary>
        /// <param name="root"></param>
        /// <param name="KeyName"></param>
        /// <returns></returns>
        public static long ReadRegLong(string root, string KeyName) {
            long lKey;
            string sKey;
            RegistryKey regist;
            try {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return 0;
                }
                else {
                    if (regist.GetValue(KeyName) == null)
                        lKey = 0;
                    else {
                        sKey = regist.GetValue(KeyName).ToString();
                        lKey = (long)Convert.ToUInt64(sKey);
                    }
                    return lKey;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                ErrorMsg(e.ToString(), "Reading registry long" + KeyName.ToUpper());
                return 0;
            }
        }  // readRegLong

        /// <summary>
        /// einlesen eines Int aus der Registry
        /// </summary>
        /// <param name="root"></param>
        /// <param name="KeyName"></param>
        /// <returns></returns>
        public static int ReadRegInt(string root, string KeyName) {
            int lKey;
            string sKey;
            RegistryKey regist;
            try {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return 0;
                }
                else {
                    if (regist.GetValue(KeyName) == null)
                        lKey = 0;
                    else {
                        sKey = regist.GetValue(KeyName).ToString();
                        lKey = (int)Convert.ToInt32(sKey);
                        //.ToUInt64(sKey);
                    }
                    return lKey;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                ErrorMsg(e.ToString(), "Reading registry int" + KeyName.ToUpper());
                return 0;
            }
        }  // readRegInt

        /// <summary>
        /// einlesen eines ULong aus der Registry
        /// </summary>
        /// <param name="root"></param>
        /// <param name="KeyName"></param>
        /// <returns></returns>
        public static ulong ReadRegULong(string root, string KeyName) {
            string sKey;
            ulong lKey = 0;
            RegistryKey regist;
            try {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return 0;
                }
                else {
                    if (regist.GetValue(KeyName) == null)
                        lKey = 0;
                    else {
                        sKey = regist.GetValue(KeyName).ToString();
                        lKey = Convert.ToUInt64(sKey);
                    }
                    return lKey;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                ErrorMsg(e.ToString(), "Reading registry double" + KeyName.ToUpper());
                return 0;
            }
        }  // readRegLong


        /// <summary>
        /// einlesen eines Double aus der Registry
        /// </summary>
        /// <param name="root"></param>
        /// <param name="KeyName"></param>
        /// <returns></returns>
        public static double ReadRegDouble(string root, string KeyName) {
            string sKey;
            double dKey = 0;
            RegistryKey regist;
            try {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return 0.0;
                }
                else {
                    if (regist.GetValue(KeyName) == null)
                        dKey = 0.0;
                    else {
                        sKey = regist.GetValue(KeyName).ToString();
                        dKey = Convert.ToDouble(sKey);
                    }
                    return dKey;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                ErrorMsg(e.ToString(), "Reading registry double" + KeyName.ToUpper());
                return 0.0;
            }
        }  // readRegDouble

        /// <summary>
        /// lesen eines Boolean aus der Registry
        /// </summary>
        /// <param name="root"></param>
        /// <param name="KeyName"></param>
        /// <returns></returns>
        public static bool ReadRegBool(string root, string KeyName) {
            bool bKey;
            RegistryKey regist;
            try {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else {
                    if (regist.GetValue(KeyName) == null)
                        bKey = false;
                    else {
                        int value = (int)regist.GetValue(KeyName);
                        bKey = value == 1;
                    }
                    return bKey;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                ErrorMsg(e.ToString(), "Reading registry bool" + KeyName.ToUpper());
                return false;
            }
        }  // readRegBool


        // WriteWriteWriteWriteWriteWriteWriteWriteWriteWriteWriteWrite

        /// <summary>
        /// schreiben eines String in die Registry
        /// </summary>
        /// <param name="root"></param>
        /// <param name="KeyName"></param>
        /// <param name="Value"></param>
        /// <returns></returns>
        public static bool WriteRegString(string root, string KeyName, string Value) {
            try {
                RegistryKey rKey = Registry.CurrentUser.CreateSubKey(root);
                if (rKey == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else {
                    rKey.SetValue(KeyName, Value, RegistryValueKind.String);
                    return true;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                ErrorMsg(e.ToString(), "Writing registry string" + KeyName.ToUpper());
                return false;
            }
        }


        /// <summary>
        /// schreiben eines ULong in die Registry
        /// </summary>
        /// <param name="root"></param>
        /// <param name="KeyName"></param>
        /// <param name="Value"></param>
        /// <returns></returns>
        public static bool WriteRegULong(string root, string KeyName, ulong Value) {
            try {
                RegistryKey rKey = Registry.CurrentUser.CreateSubKey(root);
                if (rKey == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else {
                    rKey.SetValue(KeyName, Value, RegistryValueKind.DWord);
                    return true;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                ErrorMsg(e.ToString(), "Writing registry long" + KeyName.ToUpper());
                return false;
            }
        }

        /// <summary>
        /// schreiben eines Int in die Registry
        /// </summary>
        /// <param name="root"></param>
        /// <param name="KeyName"></param>
        /// <param name="Value"></param>
        /// <returns></returns>
        public static bool WriteRegInt(string root, string KeyName, int Value) {
            try {
                RegistryKey rKey = Registry.CurrentUser.CreateSubKey(root);
                if (rKey == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else {
                    rKey.SetValue(KeyName, Value, RegistryValueKind.DWord);
                    return true;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                ErrorMsg(e.ToString(), "Writing registry int" + KeyName.ToUpper());
                return false;
            }
        }


        /// <summary>
        /// schreiben eines Double in die Registry
        /// </summary>
        /// <param name="root"></param>
        /// <param name="KeyName"></param>
        /// <param name="Value"></param>
        /// <returns></returns>
        public static bool WriteRegDouble(string root, string KeyName, double Value) {
            try {
                RegistryKey rKey = Registry.CurrentUser.CreateSubKey(root);
                if (rKey == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else {
                    rKey.SetValue(KeyName, Value.ToString(), RegistryValueKind.String);
                    return true;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                ErrorMsg(e.ToString(), "Writing registry double" + KeyName.ToUpper());
                return false;
            }
        }


        /// <summary>
        /// schreiben eines Bool in die Registry
        /// </summary>
        /// <param name="root"></param>
        /// <param name="KeyName"></param>
        /// <param name="Value"></param>
        /// <returns></returns>
        public static bool WriteRegBool(string root, string KeyName, bool Value) {
            try {
                RegistryKey rKey = Registry.CurrentUser.CreateSubKey(root);
                if (rKey == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else {
                    if (Value)
                        rKey.SetValue(KeyName, 1, RegistryValueKind.DWord);  // Bool geht nicht                    
                    else
                        rKey.SetValue(KeyName, 0, RegistryValueKind.DWord);  // Bool geht nicht                    
                    return true;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                ErrorMsg(e.ToString(), "Writing registry bool" + KeyName.ToUpper());
                return false;
            }
        }


        /// <summary>
        /// Kapselt das Einlesen, konvertieren inkl. Fehlermeldung
        /// if (!Basis.tryDecimal("Fehlerhafte Zahl",tInput, out ergebnis))
        ///     return
        /// </summary>
        /// <param name="error"></param>
        /// <param name="tItem"></param>
        /// <param name="deci"></param>
        /// <returns></returns>
        public static bool tryDecimal(String error, TextBox tItem, out decimal deci) {
            if (!decimal.TryParse(tItem.Text.Trim().Replace(',', '.'), System.Globalization.NumberStyles.AllowDecimalPoint, System.Globalization.CultureInfo.InvariantCulture, out deci)) {
                Basis.ErrorMsg(error, "Hinweis");
                tItem.Focus();
                return false;
            }
            if (deci < 0.0M) {
                Basis.ErrorMsg("Bitte geben Sie einen positiven Wert ein", "Hinweis");
                tItem.Focus();
                return false;
            }
            return true;
        }

        /// <summary>
        /// Kapselt das Einlesen, konvertieren inkl. Fehlermeldung
        /// if (!Basis.tryDecimal("Fehlerhafte Zahl",tInput, out ergebnis))
        ///     return
        /// </summary>
        /// <param name="error"></param>
        /// <param name="tItem"></param>
        /// <param name="deci"></param>
        /// <returns></returns>
        public static bool tryDecimalPosNeg(String error, TextBox tItem, out decimal deci) {
            if (!decimal.TryParse(tItem.Text.Trim().Replace(',', '.'), System.Globalization.NumberStyles.AllowDecimalPoint, System.Globalization.CultureInfo.InvariantCulture, out deci)) {
                Basis.ErrorMsg(error, "Hinweis");
                tItem.Focus();
                return false;
            }
            return true;
        }

        /// <summary>
        /// Kapselt das Einlesen, konvertieren inkl. Fehlermeldung
        /// if (!Basis.tryDouble("Fehlerhafte Zahl",tInput, out ergebnis))
        ///     return
        /// </summary>
        /// <param name="error"></param>
        /// <param name="tItem"></param>
        /// <param name="dValue"></param>
        /// <returns></returns>
        public static bool tryDouble(String error, TextBox tItem, out double dValue) {
            if (!double.TryParse(tItem.Text.Trim().Replace(',', '.'), System.Globalization.NumberStyles.AllowDecimalPoint, System.Globalization.CultureInfo.InvariantCulture, out dValue)) {
                Basis.ErrorMsg(error, "Hinweis");
                tItem.Focus();
                return false;
            }
            if (dValue < 0.0) {
                Basis.ErrorMsg("Bitte geben Sie einen positiven Wert ein", "Hinweis");
                tItem.Focus();
                return false;
            }
            return true;
        }

        /// <summary>
        /// Kapselt das Einlesen, konvertieren inkl. Fehlermeldung
        /// if (!Basis.tryInt("Fehlerhafte Zahl",tInput, out ergebnis))
        ///     return
        /// </summary>
        /// <param name="error"></param>
        /// <param name="tItem"></param>
        /// <param name="iValue"></param>
        /// <returns></returns>
        public static bool tryInt(String error, TextBox tItem, out int iValue) {
            if (!int.TryParse(tItem.Text.Trim(), out iValue)) {
                Basis.ErrorMsg(error, "Hinweis");
                tItem.Focus();
                return false;
            }
            if (iValue < 0.0M) {
                Basis.ErrorMsg("Bitte geben Sie einen positiven Wert ein", "Hinweis");
                tItem.Focus();
                return false;
            }
            return true;
        }



    }
}
