﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


using System.Windows.Controls;


namespace Company {
    public class Check {

        public static bool tryDecimal(TextBox tInput, out decimal deci) {
            deci = 0;
            if (!decimal.TryParse(tInput.Text.Trim().Replace(',', '.'), System.Globalization.NumberStyles.AllowDecimalPoint, System.Globalization.CultureInfo.InvariantCulture, out deci)) {
                return false;
            }
            if (deci < 0.0M) {
                return false;
            }
            return true;
        }


        public static bool tryDecimal(String text, out decimal deci) {
            deci = 0;
            if (!decimal.TryParse(text.Trim().Replace(',', '.'), System.Globalization.NumberStyles.AllowDecimalPoint, System.Globalization.CultureInfo.InvariantCulture, out deci)) {
                Basis.ErrorMsg("Fehlerhafte Eingabe\r\n" + text, "Hinweis");
                return false;
            }
            if (deci < 0.0M) {
                Basis.ErrorMsg("Bitte geben Sie einen positiven Wert ein\r\n" + text, "Hinweis");
                return false;
            }
            return true;
        }

        public static bool tryDecimalPosNeg(String text, out decimal deci) {
            deci = 0;
            if (!decimal.TryParse(text.Trim().Replace(',', '.'), System.Globalization.NumberStyles.AllowDecimalPoint | System.Globalization.NumberStyles.AllowLeadingSign, System.Globalization.CultureInfo.InvariantCulture, out deci)) {
                Basis.ErrorMsg("Fehlerhafte Eingabe\r\n" + text, "Hinweis");
                return false;
            }
            return true;
        }

        public static bool tryDecimal(String error, TextBox tItem, out decimal deci) {
            if (!decimal.TryParse(tItem.Text.Trim().Replace(',', '.'), System.Globalization.NumberStyles.AllowDecimalPoint, System.Globalization.CultureInfo.InvariantCulture, out deci)) {
                Basis.ErrorMsg(error, "Hinweis");
                tItem.Focus();
                return false;
            }
            if (deci < 0.0M) {
                Basis.ErrorMsg("Bitte geben Sie einen positiven Wert ein\r\n" + tItem.Text, "Hinweis");
                tItem.Focus();
                return false;
            }
            return true;
        }

        public static bool tryDecimalPosNeg(String error, TextBox tItem, out decimal deci) {
            if (!decimal.TryParse(tItem.Text.Trim().Replace(',', '.'), System.Globalization.NumberStyles.AllowDecimalPoint | System.Globalization.NumberStyles.AllowLeadingSign, System.Globalization.CultureInfo.InvariantCulture, out deci)) {
                Basis.ErrorMsg(error, "Hinweis");
                tItem.Focus();
                return false;
            }
            return true;
        }

        public static bool tryDouble(String value, out double dValue) {
            if (!double.TryParse(value.Trim().Replace(',', '.'), System.Globalization.NumberStyles.AllowDecimalPoint, System.Globalization.CultureInfo.InvariantCulture, out dValue)) {
                return false;
            }
            if (dValue < 0.0) {
                return false;
            }
            return true;
        }

        public static bool tryDouble(String error, TextBox tItem, out double dValue) {
            if (!double.TryParse(tItem.Text.Trim().Replace(',', '.'), System.Globalization.NumberStyles.AllowDecimalPoint, System.Globalization.CultureInfo.InvariantCulture, out dValue)) {
                Basis.ErrorMsg(error, "Hinweis");
                tItem.Focus();
                return false;
            }
            if (dValue < 0.0) {
                Basis.ErrorMsg("Bitte geben Sie einen posiviten Wert ein\r\n" + tItem.Text, "Hinweis");
                tItem.Focus();
                return false;
            }
            return true;
        }
        public static bool tryInt(String error, TextBox tItem, out int iValue) {
            if (!int.TryParse(tItem.Text.Trim(), out iValue)) {
                Basis.ErrorMsg(error, "Hinweis");
                tItem.Focus();
                return false;
            }
            if (iValue < 0.0M) {
                Basis.ErrorMsg("Bitte geben Sie einen posiviten Wert ein\r\n" + tItem.Text, "Hinweis");
                tItem.Focus();
                return false;
            }
            return true;
        }

        

    }
}
