﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.IO;
using System.Windows;
using System.Threading;

using System.Data;
using System.Collections.ObjectModel;
using Company.DBS_Klassen;
using Company.ViewModels;
using Company.Models;
using System.Diagnostics;
using System.Collections;

namespace Company.DBS_Klassen {
    public class Dbs_QueriesExecute {

        public static  String TBL_Department = "Department";
        public static  String TBL_Employee = "Employee";

        public static String SQL_getDepartments() {
            return "SELECT Pindex, city, country FROM "
                + TBL_Department + " ORDER BY city, country;";
        }

        public static ObservableCollection_Dept getItemsFromDept() {
            ObservableCollection_Dept dept_Class = new ObservableCollection_Dept();
            List<ModelDept> dept_Items = dept_Class.Items;
            String sql = SQL_getDepartments();
            Dbs dbs = Dbs.getInstance();
            DataTable dt = dbs.selectDBS(sql);
            ModelDept dept = null;
            foreach (System.Data.DataRow row in dt.Rows) {
                dept = new ModelDept();
                dept.Pindex = (int)row.ItemArray[0];
                dept.City = (String)row.ItemArray[1];
                dept.Country = (String)row.ItemArray[2];
                dept.newAttrib = false;
                dept.modifyAttrib = false;  // WICHTIG  !!!!!!!!!
                dept_Items.Add(dept);
            }
            return dept_Class;
        }  // ObservableCollection_Abt


        public static String SQL_getEmployees(bool sortDept, int deptindex = -1) {
            if (sortDept) {
                if (deptindex > 0)
                    return "SELECT Pindex, firstname, lastname, MONTHLYSALARY, street, ZIPCODE, city, country, mobile, rem, deptindex FROM " + TBL_Employee +
                        " WHERE deptindex=" + deptindex +
                         " ORDER BY deptIndex,lastname, firstname;";
                else
                    return "SELECT Pindex, firstname, lastname, MONTHLYSALARY, street, ZIPCODE, city, country, mobile, rem, deptindex FROM " + TBL_Employee + " ORDER BY deptIndex,lastname, firstname;";
            }
            else {
                if (deptindex > 0)
                    return "SELECT Pindex, firstname, lastname, MONTHLYSALARY, street, ZIPCODE, city, country, mobile, rem, deptindex FROM " + TBL_Employee +
                        " WHERE deptindex=" + deptindex +
                        " ORDER BY lastname, firstname;";
                else
                    return "SELECT Pindex, firstname, lastname, MONTHLYSALARY, street, ZIPCODE, city, country, mobile, rem, deptindex FROM " + TBL_Employee + " ORDER BY lastname, firstname;";
            }
        }


        public static ObservableCollection_Employee getItemsFromEmployees(bool sortDept, int deptindex = -1) {
            ObservableCollection_Employee empl_class = new ObservableCollection_Employee();
            List<ModelEmployee> liste = empl_class.Items;
            String sql = SQL_getEmployees(true, deptindex);  // Neu
            Dbs dbs = Dbs.getInstance();
            DataTable dt = dbs.selectDBS(sql);
            ModelEmployee empl = null;

            foreach (System.Data.DataRow row in dt.Rows) {
                empl = new ModelEmployee();
                empl.Pindex = (int)row.ItemArray[0];
                empl.Firstname = (String)row.ItemArray[1];
                empl.Lastname = (String)row.ItemArray[2];
                empl.Monthlysalary = (decimal)row.ItemArray[3];
                empl.Street = (String)row.ItemArray[4];
                empl.Zipcode = (String)row.ItemArray[5];
                empl.City = (String)row.ItemArray[6];
                empl.Country = (String)row.ItemArray[7];
                empl.Mobile = (String)row.ItemArray[8];
                empl.Rem = (String)row.ItemArray[9];

                empl.Deptindex = (int)row.ItemArray[10];
                empl.newAttrib = false;
                empl.modifyAttrib = false;
                liste.Add(empl);
            }
            return empl_class;
        }

        // Neu

        public static String SQL_getAbteilungenFromMitarbeiter() {
            return "SELECT DISTINCT DeptIndex FROM Employee;";
        }

        public static bool deptIsFKInEmplSale(long aindex) {
            String sql = SQL_getAbteilungenFromMitarbeiter();
            Dbs dbs = Dbs.getInstance();
            DataTable dt = dbs.selectDBS(sql);
            bool gefunden = false;
            foreach (System.Data.DataRow row in dt.Rows) {
                long ai = (int)row.ItemArray[0];
                if (ai == aindex) {
                    gefunden = true;
                    break;
                }
            }
            return gefunden;
        }


        public static String getinsertEmployee2AccessSQL(ModelEmployee empl) {
            return "INSERT INTO Employee(pindex, firstname, lastname, monthlysalary, street, zipcode, city, country, mobile, deptindex) " +
                    "Values (" + empl.Pindex + ", "
                      + empl.getFirstnameQuote() + ", "
                      + empl.getLastnameQuote() + ", "
                      + empl.Monthlysalary.ToString("#0.00").Replace(',', '.') + ", "
                      + empl.getStreetQuote() + ", "
                      + empl.getZipcodeQuote() + ", "
                      + empl.getCityQuote() + ", "
                      + empl.getCountryQuote() + ", "
                      + empl.getMobileQuote() + ", "

                      + empl.Deptindex + ");";
        }

        public static String getinsertDept2AccessSQL(ModelDept dept) {
            return "INSERT INTO Department(pindex, city, country) " +
                    "Values (" + dept.Pindex + ", " + dept.getCityQuote() + ", " + dept.getCountryQuote() + ");";
        }



        public static String SQL_getEmployeesDeptIndex() {
            return "SELECT distinct deptindex FROM " + "Employee" + " ORDER BY deptindex";
        }

        public static List<int> getEmployeesDeptIndex() {
            List<int> liste = new List<int>();
            String sql = SQL_getEmployeesDeptIndex();
            Dbs dbs = Dbs.getInstance();
            DataTable dt = dbs.selectDBS(sql);


            Stopwatch timer = new Stopwatch();
            timer.Start();

            foreach (System.Data.DataRow row in dt.Rows) {
                liste.Add((int)row.ItemArray[0]);
            }
            return liste;
        }



        public static void deleteModelDept(ModelDept dept) {
            Dbs dbs = Dbs.getInstance();
            String sql = "DELETE FROM Department WHERE pindex=" + dept.Pindex + ";";
            dbs.modifyDBS(sql);
        }

        public static void insertModelDept(ModelDept dept) {
            Dbs dbs = Dbs.getInstance();
            String sql = "INSERT INTO Department(pindex, city, country) " +
                    "Values (" + dept.Pindex + ", " + dept.getCityQuote() + ", " + dept.getCountryQuote() + ");";
            dbs.modifyDBS(sql);
        }

        public static void updateModelDept(ModelDept dept) {
            Dbs dbs = Dbs.getInstance();
            String sql = "UPDATE Department " +
                  " SET "
                  + " city=" + dept.getCityQuote() + ", "
                  + " country=" + dept.getCountryQuote() + " "
                  + " WHERE pindex=" + dept.Pindex + ";";

            dbs.modifyDBS(sql);
        }

        public static void deleteModelEmployee(ModelEmployee empl) {
            Dbs dbs = Dbs.getInstance();
            String sql = "DELETE FROM Employee WHERE pindex=" + empl.Pindex + ";";
            dbs.modifyDBS(sql);
        }

        public static void insertModelEmployee(ModelEmployee empl) {
            Dbs dbs = Dbs.getInstance();
            String sql = "INSERT INTO Employee(pindex, firstname, lastname, monthlysalary, street, zipcode, city, country, mobile,bem,  deptindex) " +
                    "Values (" + empl.Pindex + ", "
                      + empl.getFirstnameQuote() + ", "
                      + empl.getLastnameQuote() + ", "
                      + empl.Monthlysalary.ToString("#0.00").Replace(',', '.') + ", "
                      + empl.getStreetQuote() + ", "
                      + empl.getZipcodeQuote() + ", "
                      + empl.getCityQuote() + ", "
                      + empl.getCountryQuote() + ", "
                      + empl.getMobileQuote() + ", "
                      + empl.getRemQuote() + ", "

                      + empl.Deptindex + ");";
            dbs.modifyDBS(sql);
        }








        internal static void updateModelEmployee(ModelEmployee empl) {
            Dbs dbs = Dbs.getInstance();
            String sql = "UPDATE Employee " +
                  " SET "
                  + " firstname=" + empl.getFirstnameQuote() + ", "
                  + " lastname=" + empl.getLastnameQuote() + ", "
                  + " monthlysalary=" + empl.Monthlysalary.ToString("0.00").Replace(',', '.') + ", "
                  + " street=" + empl.getStreetQuote() + ", "
                  + " zipcode=" + empl.getZipcodeQuote() + ", "
                  + " city=" + empl.getCityQuote() + ", "
                  + " Country=" + empl.getCountryQuote() + ", "
                  + " mobile=" + empl.getMobileQuote() + ", "
                  + " bem=" + empl.getRemQuote()
                  + " WHERE pindex=" + empl.Pindex + ";";

            dbs.modifyDBS(sql);
        }


        /*
        public static String SQL_getDBVersion() {
            return "SELECT DBVersion, dbDate, Text FROM " + "DBVersion;";
        }


        public static String getinsertDept2AccessSQL(ModelDept dept) {
            return "INSERT INTO Department(pindex, city, country) " +
                    "Values (" + dept.Pindex + ", " + dept.getCityQuote() + ", " + dept.getCountryQuote() + ");";
        }

        public static DataTable getItemsFromEmployees() {
            ObservableCollection_Employee empl_class = new ObservableCollection_Employee();
            ObservableCollection<ModelEmployee> items = empl_class.Items;
            String sql = SQL_getEmployees(true, -1);
            Dbs dbs = Dbs.getInstance();
            return dbs.selectDBS(sql);
        }



        public static ObservableCollection_Employee getItemsFromEmployees(bool sortDept, int deptindex = -1) {
            ObservableCollection_Employee empl_class = new ObservableCollection_Employee();
            ObservableCollection<ModelEmployee> items = empl_class.Items;
            String sql = SQL_getEmployees(sortDept, deptindex);
            Dbs dbs = Dbs.getInstance();
            DataTable dt = dbs.selectDBS(sql);
            ModelEmployee empl = null;
            Stopwatch timer = new Stopwatch();
            timer.Start();

            if (dt.Rows.Count > 300) {
                int i = 0;
                foreach (System.Data.DataRow row in dt.Rows) {
                    if (i < 50) {
                        empl = new ModelEmployee();
                        empl.Pindex = (int)row.ItemArray[0];
                        empl.Firstname = (String)row.ItemArray[1];
                        empl.Lastname = (String)row.ItemArray[2];
                        empl.Monthlysalary = (decimal)row.ItemArray[3];
                        empl.Street = (String)row.ItemArray[4];
                        empl.Zipcode = (String)row.ItemArray[5];
                        empl.City = (String)row.ItemArray[6];
                        empl.Country = (String)row.ItemArray[7];
                        empl.Mobile = (String)row.ItemArray[8];
                        empl.Bem = (String)row.ItemArray[9];

                        empl.Deptindex = (int)row.ItemArray[10];
                        empl.newAttrib = false;
                        empl.modifyAttrib = false;
                        items.Add(empl);
                        i++;
                    }
                    else {
                        items.Add(new ModelEmployee(row));
                    }
                }
            }
            else {
                foreach (System.Data.DataRow row in dt.Rows) {
                    empl = new ModelEmployee();
                    empl.Pindex = (int)row.ItemArray[0];
                    empl.Firstname = (String)row.ItemArray[1];
                    empl.Lastname = (String)row.ItemArray[2];
                    empl.Monthlysalary = (decimal)row.ItemArray[3];
                    empl.Street = (String)row.ItemArray[4];
                    empl.Zipcode = (String)row.ItemArray[5];
                    empl.City = (String)row.ItemArray[6];
                    empl.Country = (String)row.ItemArray[7];
                    empl.Mobile = (String)row.ItemArray[8];
                    empl.Bem = (String)row.ItemArray[9];

                    empl.Deptindex = (int)row.ItemArray[10];
                    empl.newAttrib = false;
                    empl.modifyAttrib = false;
                    items.Add(empl);
                }
            }
            TimeSpan ts = timer.Elapsed;
            // Basis.Message(String.Format("{0:00}:{1:00}:{2:00}.{3:00}", ts.Hours, ts.Minutes, ts.Seconds, ts.Milliseconds / 10), "Länge der Zeit");

            return empl_class;
        }


        */
    }

}
