﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


using System.Data;
using Excel = Microsoft.Office.Interop.Excel;
using System.IO;

namespace Company.DBS_Klassen {
    public class Dt2Export {

        public static void Export2Excel(DataTable dt) {
            var xl = new Excel.Application();
            var wb = xl.Workbooks.Add();


            DataColumnCollection cols = dt.Columns;
            int anzCols = cols.Count;
            for (int i = 0; i < anzCols; i++) {
                xl.Cells[1, i + 1] = cols[i].Caption;
                xl.Cells[1, i + 1].Select();
                xl.ActiveCell.Font.Size = 12;
                xl.ActiveCell.Font.Bold = true;
            }


            var ws = (Microsoft.Office.Interop.Excel.Worksheet)wb.ActiveSheet;

            int col1 = anzCols / 26;
            int col2 = anzCols % 26;
            String endcolumn = "";
            if (anzCols <= 26) {
                endcolumn = ((char)(65 + col2)).ToString();
            }
            else {
                endcolumn = ((char)(64 + col1)).ToString() + ((char)(65 + col2)).ToString();
            }
            String column = "";
            char ch, ch1, ch2;
            // bestimme die Excelzelle mit der A2 bis Z2 Adressierung   A-Z   AA-AZ   BA-BZ
            for (int i = 0; i < anzCols; i++) {
                Type type = cols[i].DataType;
                if (type.FullName.Equals("System.String") || type.FullName.Equals("System.DateTime")) {
                    if (i < 26) {
                        // A-Z
                        ch = (char)(65 + i);
                        column = ch.ToString();
                    }
                    else {
                        int i1, i2;
                        i1 = i / 26;   //  26/26=1   52=BA           1. Zahl +64    2.Zahl+65
                        i2 = i % 26;
                        ch1 = (char)(64 + i1);
                        ch2 = (char)(65 + i2);
                        column = ch1.ToString() + ch2.ToString();
                        // AA - AZ   BA - BZ
                    }
                    ws.Range[column + "2:" + column + (dt.Rows.Count + 1)].Select();
                    xl.Selection.NumberFormat = "@";  // String
                }
            }


            int r = 1;
            int n = 0;
            int row = 0;
            int rowOffset = 0;
            int MAX = 20;
            Object[,] items = new Object[MAX, anzCols];
            foreach (System.Data.DataRow dbRow in dt.Rows) {
                r++;

                Object[] objs = dbRow.ItemArray;
                for (int i = 0; i < objs.Length; i++) {
                    items[n, i] = objs[i];
                }
                n++;
                rowOffset++;
                if (n == MAX) {
                    ws.Range["A2"].Offset[row].Resize[MAX, anzCols].Value = items;
                    n = 0;
                    rowOffset = 0;
                    row += MAX;
                }
            }
            if (n > 0) {
                ws.Range["A2"].Offset[row].Resize[rowOffset, anzCols].Value = items;
            }
            xl.Cells[2, 1].Select(); // row column
            xl.Visible = true;
        }  // Export2Excel



        /// <summary>
        /// 
        /// </summary>
        /// <param name="filename"></param>
        /// <param name="root"></param>
        /// <param name="tablename"></param>
        /// <param name="dt"></param>
        public static void Export2XML(String filename, String root, String tablename, DataTable dt) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            sb.AppendLine("<"+ root+" xsi:noNamespaceSchemaLocation=\"company.xsd\"");
            sb.AppendLine("xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">");

            DataColumnCollection cols = dt.Columns;
            foreach (System.Data.DataRow dbRow in dt.Rows) {
                sb.AppendLine("  <" + tablename + ">");
                Object[] objs = dbRow.ItemArray;  // aktuelle Zeile
                for (int i = 0; i < objs.Length; i++) {
                    sb.AppendLine("    <" + cols[i].Caption + ">" + objs[i] + "</" + cols[i].Caption + "> ");
                }
                sb.AppendLine("  <" + tablename + ">");
            }
            sb.AppendLine("</"+ root+">");

            File.WriteAllText(filename, sb.ToString());
        }


    }
}
