﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Company.Dialogs {
    /// <summary>
    /// Interaction logic for WOptions.xaml
    /// </summary>
    public partial class WOptions : Window {

        private String dbtable = "WOptions";

        public bool retocde = false;
        private int[] fontsizes = { 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 25, 36 };


        public WOptions(Window owner) {
            InitializeComponent();
            this.Owner = owner;
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            cbHeaderFontsize.Items.Clear();
            cbNormalFontsize.Items.Clear();
            foreach (int size in fontsizes) {
                cbHeaderFontsize.Items.Add(size + " pg");
                cbNormalFontsize.Items.Add(size + " pg");
            }
            int fHeadersize = Companyregistry.HeaderFont;
            int fNormalsize = Companyregistry.NormalFont;
            for (int i = 0; i < fontsizes.Length; i++) {
                if (fHeadersize == fontsizes[i]) {
                    cbHeaderFontsize.SelectedIndex = i;
                }
                if (fNormalsize == fontsizes[i]) {
                    cbNormalFontsize.SelectedIndex = i;
                }
            }
            setFontsize();
            Basis.setWindowPositionFromRegistry(this, Companyregistry.C_REG_ADR + "\\position", "table" + dbtable);
        }  // Window_Loaded

        private void setFontsize() {
            int fHeadersize = Companyregistry.HeaderFont;
            int fNormalsize = Companyregistry.NormalFont;
            this.FontSize = fNormalsize;
            labelTitle.FontSize = fHeadersize;
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                e.Handled = true;
                bnOk_Click(sender, e);
            }
            if (Keyboard.IsKeyDown(Key.Escape)) {
                e.Handled = true;
                bnEsc_Click(sender, e);
            }
        }
        private void bnOk_Click(object sender, RoutedEventArgs e) {
            if (cbHeaderFontsize.SelectedIndex >= 0) {
                Companyregistry.HeaderFont = fontsizes[cbHeaderFontsize.SelectedIndex];
            }
            if (cbNormalFontsize.SelectedIndex >= 0) {
                Companyregistry.NormalFont = fontsizes[cbNormalFontsize.SelectedIndex];
            }


            Close();
        }
        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_Closing(Object sender, System.ComponentModel.CancelEventArgs e) {
            Basis.writeWindowPosition2Registry(this, Companyregistry.C_REG_ADR + "\\position", "table" + dbtable);
        }
    }
}
