﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;


// Zusätzlich benötigte Verweise: System.Management.dll
// Assemblies, Suchen Management
using System.Management;

namespace Company.Dialogs {
    /// <summary>
    /// Interaction logic for WProgInfo.xaml
    /// </summary>
    public partial class WProgInfo : Window {

        private String dbtable = "WProgInfo";

        public WProgInfo(Window owner) {
            InitializeComponent();
            this.Owner = owner;
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
        }


        public static string GetWindwosClientVersion() {
            int major = System.Environment.OSVersion.Version.Major;
            int minor = System.Environment.OSVersion.Version.Minor;
            int build = System.Environment.OSVersion.Version.Build;


            if (major == 4 && minor == 0 && build == 950)
                return "Win95 Release 1";
            else if (major == 4 && minor == 0 && build == 1111)
                return "Win95 Release 2";
            else if (major == 4 && minor == 3 && (build == 1212 || build == 1213 || build == 1214))
                return "Win95 Release 2.1";
            else if (major == 4 && minor == 10 && build == 1998)
                return "Win98";
            else if (major == 4 && minor == 10 && build == 2222)
                return "Win98 Second Edition";
            else if (major == 4 && minor == 90)
                return "WinMe";
            else if (major == 5 && minor == 0)
                return "Win2000";
            else if (major == 5 && minor == 1 && build == 2600)
                return "WinXP";
            else if (major == 6 && minor == 0)
                return "Vista";
            else if (major == 6 && minor == 1)
                return "Win7";
            else if (major == 6 && minor == 2 && build == 9200)
                return "Win8 | Win8.1";
            else if (major == 6 && minor == 2 && build == 9600)
                return "Win8.1 Update 1";
            else if (major == 10 && minor == 0 && build == 10240)
                return "Win10";
            else
                return "Can not find os version.";
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            var version = System.Reflection.Assembly.GetExecutingAssembly().GetName().Version;
            int major = version.Major;
            int minor = version.Minor;
            int build = version.Build;
            int revision = version.Revision;
            this.lVersion.Content = "Version: " + major + "." + minor + "   Revision: " + revision + "   Build: " + build + " (26.04.2018)";
            // 1,1 Build 1280";
            this.lCopyright.Content = "Copyright by Company, Wernigerode";
            this.lCompanyname.Content = "Firma: Company, Friedrichstraße 57-59, Tel: 03943 / 0 123 456";

            String OSVersionaname = "";
            String OSVersionNummer = "";
            using (var mos = new ManagementObjectSearcher("SELECT Caption, Version FROM Win32_OperatingSystem")) {
                var attribs = mos.Get().OfType<ManagementObject>();
                OSVersionaname = attribs.FirstOrDefault().GetPropertyValue("Caption").ToString() ?? "Unknown";
                var OSVersion = new Version((attribs.FirstOrDefault().GetPropertyValue("Version") ?? "0.0.0.0").ToString());
                OSVersionNummer = OSVersion.ToString();
            }


            StringBuilder sb = new StringBuilder();
            sb.AppendLine("Computername: " + System.Environment.MachineName);
            sb.AppendLine("BS-Version: " + OSVersionNummer);
            // sb.AppendLine("BS-Name: " + System.Environment.Is64BitOperatingSystem);
            sb.AppendLine("BS-Name: " + OSVersionaname);

            sb.AppendLine("System-Page-Größe: " + System.Environment.SystemPageSize + " Bytes");
            sb.AppendLine("Version: " + System.Environment.Version);
            if (System.Environment.Is64BitOperatingSystem)
                sb.AppendLine("64-Bit-Version");
            else
                sb.AppendLine("32-Bit-Version");
            sb.AppendLine("Benutzername: " + System.Environment.UserName);
            sb.AppendLine("Anzahl der CPU's: " + System.Environment.ProcessorCount);
            this.textBoxDescription1.Text = sb.ToString();
            textBoxDescription1.SelectionStart = 0;
            Basis.setWindowPositionFromRegistry(this, Companyregistry.C_REG_ADR + "\\position", "table" + dbtable);
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_Closing(Object sender, System.ComponentModel.CancelEventArgs e) {
            Basis.writeWindowPosition2Registry(this, Companyregistry.C_REG_ADR + "\\position", "table" + dbtable);
        }
    }
}

