﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Company.Models {
    public class ModelDept: ModelBase {


        private int pindex;
        public int Pindex {
            get { return pindex;  }
            set {
                if (pindex!= value) {
                    pindex = value;
                    base.NotifyPropertyChanged("Pindex");
                    
                }
            }
        }
        
        private int nr;
        public int Nr {
            get { return nr; }
            set { nr = value; }
        }

        private String city;
        public String City {
            get { return city; }
            set {
                if (!city.Equals(value)) {
                    base.NotifyPropertyChanged("City");
                    city = value;
                }
            }
        }
        public String getCityQuote() {
            return "'" + city + "'";
        }

        private String country;
        public String Country {
            get { return country; }
            set {
                if (!country.Equals(value)) {
                    base.NotifyPropertyChanged("Country");
                    country = value;
                }
            }
        }
        public String getCountryQuote() {
            return "'" + country + "'";
        }

        public ModelDept()
            : this(-1, "", "") {
        }

        public ModelDept(int pindex, String city, String country) {
            this.pindex = pindex;
            this.city = city;
            this.country = country;
        }

        // NEU
        public ModelDept(ModelDept dept) {
            Pindex = dept.pindex;
            City = dept.city;
            Country = dept.country;
        }


        public override int CompareTo(object obj) {
            if (obj is ModelDept) {
                ModelDept dept = (ModelDept)obj;
                return city.CompareTo(dept.city);
            }
            else {
                return -1;
            }
        }

        public override string ToString() {
            return city + ", " + country;
        }

        // neuerCode
        // benoetigt in Aendern
        // Problem:
        // berlin, de   bochum,de 
        // aendern bochum, de  in berlin de
        // im Dialog wurde die Referenz geaendert
        // beim Abbruch des Dialogs bleint der alte Wert
        public void init(ModelDept dept, bool modify) {
            if (modify) {
                if (pindex != dept.pindex) this.modifyAttrib = true;
                if (!city.Equals(dept.city)) this.modifyAttrib = true;
                if (!country.Equals(dept.country)) this.modifyAttrib = true;
            }
            pindex = dept.pindex;
            city = dept.city;
            country = dept.country;
        } // init

        public void save2Xml(StringBuilder sb, bool closeDepartment=true) {
            sb.AppendLine("  <Department>");
            sb.AppendLine("    <Pindex>" + pindex + "</Pindex>");
            sb.AppendLine("    <City>" + city + "</City>");
            sb.AppendLine("    <Country>" + country + "</Country>");
            if (closeDepartment) {
                sb.AppendLine("  </Department>");
            }            
        }
        

        // Excel Export
        public static Object[] CaptionItemArray {
            get {
                Object[] items = new Object[2];
                items[0] = "Stadt";
                items[1] = "Land";

                return items;
            }
        }


        public void insertinItemArray(int row, Object[,] items) {
            items[row, 0] = city;
            items[row, 1] = country;
        }

        public void insertinItemArray(Object[] items) {
            items[0] = city;
            items[1] = country;
        }



    }  // class ModelDept
}
