﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Data;
using System.Runtime.Serialization;
using System.Xml.Serialization;
using System.Xml;
using System.Xml.Schema;

namespace Company.Models {
    public class ModelEmployee : ModelBase {



        public ModelEmployee() {   // : this(-1, "", "", 0, -1) {
        }

        public ModelEmployee(long pindex, String firstname, String lastname, decimal monthsalary, int aindex) {
            Firstname = firstname;
            Lastname = lastname;
            Monthlysalary = monthsalary;
            Deptindex = aindex;
        }
        public ModelEmployee(DataRow row) {
            this.newAttrib = false;
            this.modifyAttrib = false;
        }

        private int pindex = -1;
        public int Pindex {
            get {
                return pindex;
            }
            set {
                if (pindex != value) {
                    modifyAttrib = true;
                    pindex = value;
                    NotifyPropertyChanged("Pindex");
                }
            }
        }

        private String firstname = "";
        public String Firstname {
            get {
                return firstname;
            }
            set {
                if (firstname != value) {
                    modifyAttrib = true;
                    firstname = value;
                    NotifyPropertyChanged("Firstname");
                }
            }
        }
        public String getFirstnameQuote() {
            return "'" + firstname + "'";
        }

        private String lastname = "";
        public String Lastname {
            get {
                return lastname;
            }
            set {
                if (lastname != value) {
                    modifyAttrib = true;
                    lastname = value;
                    NotifyPropertyChanged("Lastname");
                }
            }
        }
        public String getLastnameQuote() {
            if (lastname.IndexOf("'") >= 0) {
                return "'" + lastname.Replace("'", "''") + "'";
            }
            else {
                return "'" + lastname + "'";
            }
        }



        private String zipcode;
        public String Zipcode {
            get {
                return zipcode;
            }
            set {
                if (value != zipcode) {
                    NotifyPropertyChanged("Zipcode");
                    modifyAttrib = true;
                    zipcode = value;
                    System.Diagnostics.Debug.WriteLine("Change Zipcode: " + zipcode);
                }
            }
        }
        public String getZipcodeQuote() {
            return "'" + zipcode + "'";
        }



        private String city;
        public String City {
            get {
                return city;
            }
            set {
                if (value != city) {
                    NotifyPropertyChanged("City");
                    modifyAttrib = true;
                    city = value;
                    System.Diagnostics.Debug.WriteLine("Change Lastname: " + city);
                }
            }
        }
        public String getCityQuote() {
            return "'" + city + "'";
        }



        private String street;
        public String Street {
            get {
                return street;
            }
            set {
                if (value != lastname) {
                    NotifyPropertyChanged("Street");
                    modifyAttrib = true;
                    street = value;
                    System.Diagnostics.Debug.WriteLine("Change Lastname: " + street);
                }
            }
        }
        public String getStreetQuote() {
            return "'" + street + "'";
        }


        private String country;
        public String Country {
            get {
                return country;
            }
            set {
                if (value != lastname) {
                    NotifyPropertyChanged("Country");
                    modifyAttrib = true;
                    country = value;
                    System.Diagnostics.Debug.WriteLine("Change Lastname: " + country);
                }
            }
        }
        public String getCountryQuote() {
            return "'" + country + "'";
        }


        private decimal monthlysalary = 0.0m;
        public decimal Monthlysalary {
            get {
                return monthlysalary;
            }
            set {
                if (value != monthlysalary) {
                    NotifyPropertyChanged("Monthlysalary");
                    modifyAttrib = true;
                    monthlysalary = value;
                    Yearsalary = monthlysalary * 12.0m;
                    System.Diagnostics.Debug.WriteLine("Change Monthlysalary: " + monthlysalary);
                }
            }
        }

        public void updateYearsalary() {
            NotifyPropertyChanged("Yearsalary");
            System.Diagnostics.Debug.WriteLine("updateYearsalary: " + yearsalary);
        }

        // muss vorhanden sein, für die Datagrid
        private decimal yearsalary = 0.0m;
        public decimal Yearsalary {
            get {
                return yearsalary;
            }
            set {
                if (value != yearsalary) {
                    NotifyPropertyChanged("Yearsalary");
                    modifyAttrib = true;
                    yearsalary = value;
                    monthlysalary = yearsalary / 12;
                    NotifyPropertyChanged("Monthlysalary");
                    System.Diagnostics.Debug.WriteLine("Change Yearsalary: " + yearsalary);
                }
            }
        }




        private String mobile;
        public String Mobile {
            get {
                return mobile;
            }
            set {
                if (value != mobile) {
                    NotifyPropertyChanged("Mobile");
                    modifyAttrib = true;
                    mobile = value;
                    System.Diagnostics.Debug.WriteLine("Change Mobile: " + country);
                }
            }
        }
        public String getMobileQuote() {
            return "'" + mobile + "'";
        }



        private String rem;
        public String Rem {
            get {
                return rem;
            }
            set {
                if (value != rem) {
                    NotifyPropertyChanged("Rem");
                    modifyAttrib = true;
                    rem = value;
                    System.Diagnostics.Debug.WriteLine("Change Bem: " + rem);
                }
            }
        }
        public String getRemQuote() {
            return "'" + rem + "'";
        }


        private int deptindex;
        public int Deptindex {
            get {
                return deptindex;
            }
            set {
                if (value != deptindex) {
                    NotifyPropertyChanged("Deptindex");
                    modifyAttrib = true;
                    deptindex = value;
                }
            }
        }

        public void init(ModelEmployee empl, bool modify) {
            if (modify) {
                if (pindex != empl.pindex) this.modifyAttrib = true;
                if (!firstname.Equals(empl.firstname)) this.modifyAttrib = true;
                if (!lastname.Equals(empl.lastname)) this.modifyAttrib = true;
                if (monthlysalary != empl.monthlysalary) this.modifyAttrib = true;
                if (!street.Equals(empl.street)) this.modifyAttrib = true;
                if (!zipcode.Equals(empl.zipcode)) this.modifyAttrib = true;
                if (!city.Equals(empl.city)) this.modifyAttrib = true;
                if (!country.Equals(empl.country)) this.modifyAttrib = true;
                if (!mobile.Equals(empl.mobile)) this.modifyAttrib = true;
                if (deptindex != empl.deptindex) this.modifyAttrib = true;
            }
            pindex = empl.pindex;
            firstname = empl.firstname;
            lastname = empl.lastname;
            monthlysalary = empl.monthlysalary;
            street = empl.street;
            zipcode = empl.zipcode;
            city = empl.city;
            country = empl.country;
            mobile = empl.mobile;
            deptindex = empl.deptindex;
        } // init

        public override int CompareTo(object obj) {
            ModelEmployee empl = (ModelEmployee)obj;
            int i = lastname.CompareTo(empl.lastname);
            if (i != 0)
                return i;
            else
                return firstname.CompareTo(empl.firstname);
        }



        public override String ToString() {
            return lastname + "   " + firstname+"  "+monthlysalary.ToString("0,00") + "  "+ zipcode + "  " +city + "  " +country + "  " +mobile;
        }



        public void save2Xml(StringBuilder sb) {
            sb.AppendLine("  <Employee>");
            sb.AppendLine("    <Pindex>" + pindex + "</Pindex>");
            sb.AppendLine("    <Firstname>" + firstname + "</Firstname>");
            sb.AppendLine("    <Lastname>" + lastname + "</Lastname>");
            sb.AppendLine("    <Monthlysalary>" + monthlysalary + "</Monthlysalary>");
            sb.AppendLine("    <Street>" + street + "</Street>");
            sb.AppendLine("    <Zipcode>" + zipcode + "</Zipcode>");
            sb.AppendLine("    <City>" + city + "</City>");
            sb.AppendLine("    <Country>" + country + "</Country>");
            sb.AppendLine("    <Mobile>" + mobile + "</Mobile>");
            sb.AppendLine("    <Remark>" + rem + "</Remark>");
            sb.AppendLine("    <Deptindex>" + deptindex + "</Deptindex>");
            sb.AppendLine("  </Employee>");
        }


        public void WriteXml(XmlWriter writer) {
            // writer.WriteString(pindex.ToString());
            writer.WriteStartElement("Employee");
            writer.WriteElementString("Pindex", pindex.ToString());
            writer.WriteElementString("Firstname", firstname);
            writer.WriteElementString("Lastname", lastname);
            writer.WriteElementString("Monthlysalary", monthlysalary.ToString("0.00").Replace(',', '.'));
            writer.WriteElementString("Street", street);
            writer.WriteElementString("Zipcode", zipcode);
            writer.WriteElementString("City", city);
            writer.WriteElementString("Country", country);
            writer.WriteElementString("Mobile", mobile);
            writer.WriteElementString("Remark", rem);
            writer.WriteElementString("Deptindex", deptindex.ToString());
            writer.WriteEndElement();
        }

        public XmlSchema GetSchema() {
            return (null);
        }
        public void ReadXml(XmlReader reader) {
            //  personName = reader.ReadString();
        }

        public void save2Json(StringBuilder sb, bool lastitem) {
            sb.AppendLine("    {");
            sb.AppendLine("    \t\"Pindex\": \"" + pindex + "\",");
            sb.AppendLine("    \t\"Firstname\": \"" + firstname + "\",");
            sb.AppendLine("    \t\"Lastname\": \"" + lastname + "\",");
            sb.AppendLine("    \t\"Monthlysalary\": \"" + monthlysalary.ToString("0.00").Replace(',', '.') + "\",");
            sb.AppendLine("    \t\"Street\": \"" + street + "\",");
            sb.AppendLine("    \t\"Zipcode\": \"" + zipcode + "\",");
            sb.AppendLine("    \t\"City\": \"" + city + "\",");
            sb.AppendLine("    \t\"Country\": \"" + country + "\",");
            sb.AppendLine("    \t\"Mobile\": \"" + mobile + "\",");
            sb.AppendLine("    \t\"Remark\": \"" + rem + "\"");
            sb.AppendLine("    \t\"Deptindex\": \"" + deptindex + "\"");
            if (lastitem)
                sb.AppendLine("    }");
            else
                sb.AppendLine("    },");

        }




        public static String[] CaptionItemArray {
            get {
                String[] items = new String[10];
                items[0] = "Nr";
                items[1] = "Vorname";
                items[2] = "Nachname";
                items[3] = "Monatsgehalt";
                items[4] = "Jahresgehalt";

                items[5] = "Straße";
                items[6] = "PLZ";
                items[7] = "Stadt";
                items[8] = "Land";
                items[9] = "Handy";

                return items;
            }
        }

        public Object[] ItemArray(int nr) {
            Object[] items = new Object[10];
            items[0] = nr.ToString();
            items[1] = firstname;
            items[2] = lastname;
            items[3] = monthlysalary;
            items[4] = yearsalary;
            items[5] = street;
            items[6] = zipcode;
            items[7] = city;
            items[8] = country;
            items[9] = mobile;

            return items;
        }


        // Neu
        public void insertinItemArray(int row, Object[,] items) {
            items[row, 0] = firstname;
            items[row, 1] = lastname;
            items[row, 2] = monthlysalary;
            items[row, 3] = yearsalary;
            items[row, 4] = street;
            items[row, 5] = zipcode;
            items[row, 6] = city;
            items[row, 7] = country;
            items[row, 8] = mobile;
            //items[row, 7] = HashTable.HashDepartment.getDept(deptindex).Country;
        }



    }
}
