﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;


using System.Collections.ObjectModel;
using System.Data;
using System.ComponentModel;
using System.Collections.Specialized; // ICollectionView
using Company.UserControls;
using Company.DBS_Klassen;
using Company.ViewModels;
using Company.Models;
using Company.ViewsDialog;

using Excel = Microsoft.Office.Interop.Excel;
using System.Diagnostics;
using System.Threading;
using Microsoft.Win32;



namespace Company.Views {
    /// <summary>
    /// Interaction logic for WDepartment1.xaml
    /// </summary>
    public partial class WDepartment1 : Window, INavigatorbar {

        private String dbtable = "WDepartment1";

        ObservableCollection_Dept dept_class;
        List<ModelDept> dept_Items;
        String filter = "";
                

        public WDepartment1(Window owner) {
            InitializeComponent();
            this.Owner = owner;
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;


            this.dept_class = Dbs_QueriesExecute.getItemsFromDept();
            this.dept_Items = dept_class.Items;

        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            navibar.setDatabaseParent(this, 1);
            int n = datagrid.Columns.Count;
            Title = "Anzahl: " + dept_Items.Count.ToString();

            datagrid.Columns[0].Width = 100;
            datagrid.Columns[2].Width = 50;
            datagrid.Columns[1].Width = 300; // datagrid.Width - 200;

            datagrid.ToolTip = "Bearbeiten mit einem Doppelklick";
            datagrid.IsReadOnly = true;  // Änderung
            datagrid.CanUserAddRows = false;
            datagrid.CanUserDeleteRows = false;
            datagrid.CanUserResizeColumns = true;
            datagrid.CanUserSortColumns = true;

            datagrid.ItemsSource = dept_class.Items;  // one way

            navibar.setCount(dept_class.Items.Count, dept_class.Items.Count);
            Basis.setWindowPositionFromRegistry(this, Companyregistry.C_REG_ADR + "\\position", "table" + dbtable);
        }


        /*

        public void setFirst(int nr) {
            datagrid.SelectedIndex = 0;
            datagrid.ScrollIntoView(datagrid.SelectedItem);
            datagrid.Focus();
        }

        public void setPrev(int nr) {
            if (datagrid.SelectedIndex > 0) {
                datagrid.SelectedIndex = datagrid.SelectedIndex - 1;
                //datagrid.SelectedItem = abtitems[datagrid.SelectedIndex - 1];
                //datagrid.UpdateLayout();
                datagrid.ScrollIntoView(datagrid.SelectedItem);
                datagrid.Focus();
            }
        }

        public void setNext(int nr) {
            if (datagrid.SelectedIndex < (dept_Items.Count - 1)) {
                datagrid.SelectedIndex = datagrid.SelectedIndex + 1;
                //datagrid.SelectedItem = abtitems[datagrid.SelectedIndex + 1];
                //datagrid.UpdateLayout();
                datagrid.ScrollIntoView(datagrid.SelectedItem);
                datagrid.Focus();
            }
        }

        public void setLast(int nr) {
            datagrid.SelectedIndex = dept_Items.Count - 1;
            datagrid.ScrollIntoView(datagrid.SelectedItem);
            datagrid.Focus();
        }
        */

        public void setInsert(int nr) {
            ModelDept dept = new ModelDept();
            bool error = true;
            while (error) {
                error = false;
                WInputDept dialog = new WInputDept(this, true, dept);
                dialog.ShowDialog();
                if (!dialog.Retcode) return;
                // test auf doppelte Items
                String cityUpper = dept.City;
                String countryUpper = dept.Country;
                for (int i = 0; i < dept_Items.Count; i++) {
                    String sk = dept_Items[i].City.ToUpper();
                    if (dept_Items[i].City.ToUpper().Equals(cityUpper) && dept_Items[i].Country.ToUpper().Equals(countryUpper)) {
                        MessageBox.Show("Die Niederlassung ist schon vorhanden.", "Neuer Eintrag", MessageBoxButton.OK, MessageBoxImage.Error);
                        error = true;
                        break;
                    }
                }
                if (error) continue;

                error = false;
                dept_Items.Add(dept);
                setFilter(1, this.filter);
            }
        }

        public void setDelete(int nr) {
            ModelDept abt = (ModelDept)datagrid.SelectedItem;
            if (abt != null) {
                // check, ob die Abteilung noch benutzt wird?
                bool gefunden = Dbs_QueriesExecute.deptIsFKInEmplSale(abt.Pindex);
                if (gefunden) {
                    Basis.Message("Diese Abteilung darf nicht gelöscht werden, da sie noch verwendet wird", "Hinweis");
                }
                else {
                    if (Basis.readYesNo("Wollen Sie wirklich diese Abteilung löschen ?\r\n" +
                        "Abteilung: " + abt.City + " (" + abt.Country + ")", "Abteilung löschen")) {
                        dept_class.Delete(abt);
                        setFilter(1, this.filter);
                    }
                }
            }
        }

        private void datagrid_SelectionChanged(object sender, SelectionChangedEventArgs e) {
            if (datagrid.SelectedIndex >= 0) {
                ModelDept dept = dept_Items[datagrid.SelectedIndex];
                LDepartment.Content = dept.City + ", " + dept.Country;
            }
        }



        private void datagrid_MouseDoubleClick(object sender, MouseButtonEventArgs e) {
            int index = datagrid.SelectedIndex;
            if (index >= 0) {
                bool error = true;
                ModelDept dept = (ModelDept)datagrid.SelectedItem;
                int pindex = dept.Pindex;
                ModelDept dept2 = new ModelDept();
                while (error) {
                    // neuerCode
                    dept2.init(dept, false);
                    WInputDept dialog = new WInputDept(this, false, dept2);
                    dialog.ShowDialog();
                    if (!dialog.Retcode) return;

                    error = false;
                    for (int i = 0; i < dept_Items.Count; i++) {
                        if (dept_Items[i].Pindex != dept2.Pindex && dept2.City == dept_Items[i].City && dept2.Country == dept_Items[i].Country) {
                            MessageBox.Show("Die Niederlassung ist schon vorhanden.", "Eintrag bearbeiten", MessageBoxButton.OK, MessageBoxImage.Error);
                            error = true;
                            break;
                        }
                    }
                    if (error) continue;
                    dept.init(dept2, true);
                    datagrid.Items.Refresh();
                    datagrid.Focus();
                    datagrid_SelectionChanged(null, null);
                    setFilter(1, this.filter);
                }
            }
        }




        String[] filteritems = null;
        public void setFilter(int nr, String filter) {
            this.filter = filter;
            string[] splitStrings = { ";" };
            filteritems = filter.Split(splitStrings, StringSplitOptions.None);
            int n = 0;
            foreach (ModelDept dept in dept_Items) {
                dept.isChecked = true;
                if (filter.Length > 0) {
                    foreach (String item in filteritems) {
                        if (!dept.City.StartsWith(item)) dept.isChecked = false;
                    }
                }
                if (dept.isChecked) {
                    n++;
                }
            }
            datagrid.ItemsSource = from dept in dept_Items
                                   where dept.isChecked
                                   select dept;
            navibar.setCount(n, dept_class.Items.Count);
        }

        public void setFilter2(String filter) {
            this.filter = filter;
            foreach (ModelDept dept in dept_Items) {
                dept.isChecked = true;
                if (filter.Length > 0) {
                    if (!dept.City.StartsWith(filter)) dept.isChecked = false;
                }
            }
            datagrid.ItemsSource = from dept in dept_Items
                                   where dept.isChecked
                                   select dept;
        }


        public void setFilter3(String filter) {
            this.filter = filter;
            if (filter.Length == 0) {
                //datagrid.ItemsSource = abtitems;
                ICollectionView cv = CollectionViewSource.GetDefaultView(datagrid.ItemsSource);
                cv.Filter = null;
            }
            else {
                ICollectionView cv = CollectionViewSource.GetDefaultView(datagrid.ItemsSource);
                cv.Filter = abt => (abt as ModelDept).City.StartsWith(filter);
                //var fc = from dept in abtitems
                //         where dept.KurzBez.Contains(filter)
                //         select dept;
                //datagrid.ItemsSource = fc;
            }

            // MyObservableCollection<Katalog> FilteredData = new MyObservableCollection<Katalog>(fc);           
        }

        private bool getModify() {
            bool modify = false;
            foreach (ModelDept abt in dept_Items) {
                if (abt.modifyAttrib) modify = true;
                if (abt.newAttrib) modify = true;
            }
            if (dept_class.getDeleteItemsCount() > 0) modify = true;
            return modify;
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            if (getModify()) {
                dept_class.save2Database();
            }
            Close();
        }


        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void bnChart_Click(object sender, RoutedEventArgs e) {
            if (datagrid.SelectedItems.Count > 0) {
                List<ModelChart> deptListe = new List<ModelChart>();
                foreach (ModelDept dept in datagrid.SelectedItems) {
                    ModelChart chart = new ModelChart();
                    chart.pindex = dept.Pindex;
                    chart.xValue = dept.City;
                    deptListe.Add(chart);
                }
                Mouse.OverrideCursor = Cursors.Wait;
                foreach (ModelChart chart in deptListe) {
                    decimal completeSalary = 0.0m;
                    List<ModelEmployee> listeEmpl = Dbs_QueriesExecute.getItemsFromEmployees(false, chart.pindex).Items;
                    foreach (ModelEmployee empl in listeEmpl) {
                        completeSalary += empl.Monthlysalary;
                    }
                    chart.yValue = completeSalary;
                }
                Mouse.OverrideCursor = null;
                (new WChartDeptEmployee(this, "Summe der Gehälter", deptListe)).ShowDialog();
            }
            else {
                Basis.Message("Bitte wählen Sie mindestens eine Abteilung aus", "Hinweis");
            }

        }

        


        private BackgroundWorker worker = null;

        private void progressing(int runMethodNumber, int anz) {
            progressbar.Maximum = anz+1;  // caption + n
            worker = new BackgroundWorker();
            worker.WorkerReportsProgress = true;
            worker.ProgressChanged += worker_ProgressChanged;
            switch (runMethodNumber) {
                case 0:
                    worker.DoWork += export2ExcelBiff;
                    break;
                case 1:
                    worker.DoWork += Export2Excel1;
                    break;
                case 2:
                    worker.DoWork += Export2Excel2;
                    break;
                case 3:
                    worker.DoWork += Export2Excel3;
                    break;
                case 4:
                    worker.DoWork += save2Access;
                    break;

                default:
                    Basis.ErrorMsg("Wrong case\r\nNumber: " + runMethodNumber, "progressing");
                    break;
            }
            // save2Access;  // die run-Methode
            worker.RunWorkerAsync();
        } // progressing



        // Wichtig, diese Methode wird nach jeder Änderung aufgerufen.
        // Die Abfrage "istEnde" dient als EndeAktion
        void worker_ProgressChanged(object sender, ProgressChangedEventArgs e) {
            progressbar.Value = e.ProgressPercentage;
            if (e.ProgressPercentage == progressbar.Maximum) {
                progressbar.Value = 0;
                // Basis.Message("Habe fertig", "Export");
            }
        }


        private int getNumbers2Export() {
            int summe = 0;
            foreach (ModelDept dept in dept_Items) {
                if (dept.isChecked) {
                    summe++;
                }
            }
            return summe;
        }
        private void bnExport2Biff_Click(object sender, RoutedEventArgs e) {
            progressing(0, getNumbers2Export());  // export2ExcelBiff
        }
        private void bnExport2Excel1_Click(object sender, RoutedEventArgs e) {
            progressing(1, getNumbers2Export());  // Export2Excel1
        }
        private void bnExport2Excel2_Click(object sender, RoutedEventArgs e) {
            progressing(2, getNumbers2Export());  // Export2Excel2
        }

        private void bnExport2Excel3_Click(object sender, RoutedEventArgs e) {
            progressing(3, getNumbers2Export());  // Export2Excel3
        }
        private void bnAccess_Click(object sender, RoutedEventArgs e) {
            progressing(4, 3);
        }  // bnAccess_Click


        private void export2ExcelBiff(object sender, DoWorkEventArgs e) {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Filter = "Excel-Datei (*.xls)|*.xls|All files (*.*)|*.*";
            saveFileDialog1.FilterIndex = 1;// zählt von 1 !
            saveFileDialog1.DefaultExt = ".xls";
            saveFileDialog1.InitialDirectory = Environment.CurrentDirectory;
            if (saveFileDialog1.ShowDialog() == true) {
                String filename = saveFileDialog1.FileName.ToString();
                Export2EXCEL exportexcel = new Export2EXCEL(filename);
                exportexcel.openFile();
                // header
                exportexcel.Write(0, 0, "Nr");
                exportexcel.Write(1, 0, "Stadt");
                exportexcel.Write(2, 0, "Land");
                worker.ReportProgress(1); Thread.Sleep(5);

                int row = 0;
                foreach (ModelDept dept in dept_Items) {
                    if (dept.isChecked) {
                        row++;
                        exportexcel.Write(0, row, row);
                        exportexcel.Write(1, row, dept.City);
                        exportexcel.Write(2, row, dept.Country);
                        worker.ReportProgress(row + 1);  // Thread.Sleep(5);
                    }
                }

                exportexcel.closeFile();
                Process Prog = new Process();
                Prog.StartInfo.FileName = "excel.exe";
                Prog.StartInfo.Arguments = filename;
                Prog.Start();
            }
        }

        private void Export2Excel1(object sender, DoWorkEventArgs e) {
            Stopwatch stopWatch1 = new Stopwatch();
            stopWatch1.Start();
            var xl = new Excel.Application();
            var wb = xl.Workbooks.Add();

            xl.Cells[1, 1] = "Nr";  //Row,Column
            xl.Cells[1, 1].Select();
            xl.ActiveCell.Font.Size = 12;
            xl.ActiveCell.Font.Bold = true;

            xl.Cells[1, 2] = "Stadt";
            xl.Cells[1, 2].Select();
            xl.ActiveCell.Font.Size = 12;
            xl.ActiveCell.Font.Bold = true;

            xl.Cells[1, 3] = "Land";
            xl.Cells[1, 3].Select();
            xl.ActiveCell.Font.Size = 12;
            xl.ActiveCell.Font.Bold = true;
            worker.ReportProgress(1); Thread.Sleep(5);

            var ws = (Microsoft.Office.Interop.Excel.Worksheet)wb.ActiveSheet;

            int row = 0;
            ws.Range["A2:B" + (dept_Items.Count + 1)].Select();
            xl.Selection.NumberFormat = "@";  // String

            foreach (ModelDept dept in dept_Items) {
                if (dept.isChecked) {
                    row++;
                    xl.Cells[row, 1] = (row - 1).ToString();  //Row,Column
                    xl.Cells[row, 2] = dept.City;
                    xl.Cells[row, 3] = dept.Country;
                    worker.ReportProgress(row);  // Thread.Sleep(5);
                }
                
            }
            stopWatch1.Stop();
            TimeSpan ts = stopWatch1.Elapsed;
            Basis.Message(String.Format("{0:00}:{1:00}:{2:00}.{3:00}", ts.Hours, ts.Minutes, ts.Seconds, ts.Milliseconds / 10), "Länge der Zeit");
            xl.Visible = true;

        }  // bnExport2Excel1_Click  


        private void Export2Excel2(object sender, DoWorkEventArgs e) {
            Stopwatch stopWatch1 = new Stopwatch();
            stopWatch1.Start();
            var xl = new Excel.Application();
            var wb = xl.Workbooks.Add();

            int anzCols = ModelEmployee.CaptionItemArray.Length;
            for (int i = 0; i < anzCols; i++) {
                xl.Cells[1, i + 1] = ModelEmployee.CaptionItemArray[i]; //Row,Column
                xl.Cells[1, i + 1].Select();
                xl.ActiveCell.Font.Size = 12;
                xl.ActiveCell.Font.Bold = true;
            }
            worker.ReportProgress(1); Thread.Sleep(5);

            var ws = (Microsoft.Office.Interop.Excel.Worksheet)wb.ActiveSheet;

            int rowOffset = 0;
            int row = 0;
            int iIndex = 0;
            ws.Range["A2:B" + (dept_Items.Count + 1)].Select();
            xl.Selection.NumberFormat = "@";  // String

            Object[] items = new Object[anzCols];
            foreach (ModelDept dept in dept_Items) {
                if (dept.isChecked) {
                    iIndex++;
                    dept.insertinItemArray(items);
                    rowOffset++;
                    ws.Range["A2"].Offset[row].Resize[1, anzCols].Value = items;
                    rowOffset = 0;
                    row++;
                    worker.ReportProgress(row);  // Thread.Sleep(5);
                }
            }
            stopWatch1.Stop();
            TimeSpan ts = stopWatch1.Elapsed;
            Basis.Message(String.Format("{0:00}:{1:00}:{2:00}.{3:00}", ts.Hours, ts.Minutes, ts.Seconds, ts.Milliseconds / 10), "Länge der Zeit");
            xl.Visible = true;
        }  // bnExport2Excel2_Click    


        private void Export2Excel3(object sender, DoWorkEventArgs e) {
            Stopwatch stopWatch1 = new Stopwatch();
            stopWatch1.Start();
            var xl = new Excel.Application();
            var wb = xl.Workbooks.Add();

            int anzCols = ModelEmployee.CaptionItemArray.Length;
            for (int i = 0; i < anzCols; i++) {
                xl.Cells[1, i + 1] = ModelEmployee.CaptionItemArray[i]; //Row,Column
                xl.Cells[1, i + 1].Select();
                xl.ActiveCell.Font.Size = 12;
                xl.ActiveCell.Font.Bold = true;
            }
            worker.ReportProgress(1); Thread.Sleep(5);

            var ws = (Microsoft.Office.Interop.Excel.Worksheet)wb.ActiveSheet;

            int n = 0;
            int rowOffset = 0;
            int row = 0;
            int iIndex = 0;
            int MAX = 10;
            ws.Range["A2:B" + (dept_Items.Count + 1)].Select();
            xl.Selection.NumberFormat = "@";  // String

            Object[,] items = new Object[MAX, anzCols];
            foreach (ModelDept emp in dept_Items) {
                if (emp.isChecked) {
                    iIndex++;
                    n++;
                    emp.insertinItemArray(rowOffset, items);
                    rowOffset++;
                    if (n == MAX) {
                        ws.Range["A2"].Offset[row].Resize[MAX, anzCols].Value = items;
                        n = 0;
                        rowOffset = 0;
                        row += MAX;
                    }
                    worker.ReportProgress(n+1);  // Thread.Sleep(5);
                }
            }
            if (n > 0) {
                ws.Range["A2"].Offset[row].Resize[rowOffset, anzCols].Value = items;
            }
            stopWatch1.Stop();
            TimeSpan ts = stopWatch1.Elapsed;
            Basis.Message(String.Format("{0:00}:{1:00}:{2:00}.{3:00}", ts.Hours, ts.Minutes, ts.Seconds, ts.Milliseconds / 10), "Länge der Zeit");
            xl.Visible = true;
        } // bnExport2Excel3_Click    



        private void save2Access(object sender, DoWorkEventArgs e) {
            // hier fehlt Code
            Basis.createPath(Basis.getProgPath() + "access\\");
            String accessFilename = Basis.getProgPath() + "access\\monatsbericht.mdb";
            // ' NOTE: to use ADOX add reference to COM Microsoft ADO Ext. 2.6 for DDL and Security!
            // Register    COM  Tpye Library, suche ADO
            AccessDB.createAccessDatei(accessFilename);

            worker.ReportProgress(1); Thread.Sleep(30);
            AccessDB.insertAccessTables(accessFilename, Basis.getProgPath() + "access.txt");

            worker.ReportProgress(2); Thread.Sleep(30);
            AccessDB.exportDepts(accessFilename);

            worker.ReportProgress(3); Thread.Sleep(30);
            AccessDB.exportEmployee(accessFilename);

            Process Prog = new Process();
            Prog.StartInfo.FileName = accessFilename;
            Prog.StartInfo.Arguments = "";
            Prog.Start();
        }
        

        private void Window_Closing(object sender, CancelEventArgs e) {
            e.Cancel = false;
            if (getModify()) {
                MessageBoxResult res = Basis.readYesNoCancel("Sollen die Änderungen gespeichert werden?", "Dialog beenden");
                switch (res) {
                    case MessageBoxResult.Yes: dept_class.save2Database(); break;
                    case MessageBoxResult.No: break;
                    case MessageBoxResult.Cancel: e.Cancel = false; return;
                }
            }
            Basis.writeWindowPosition2Registry(this, Companyregistry.C_REG_ADR + "\\position", "table" + dbtable);
        }

    }
}
