﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using Company.ViewModels;
using Company.Models;
using Company.DBS_Klassen;

// Excel
// Verweis  COM  Excel
using Excel = Microsoft.Office.Interop.Excel;
using System.Diagnostics;
using System.ComponentModel;
using Microsoft.Win32;
using System.Threading;
using Company.UserControls;
using Company.ViewsDialog;

namespace Company.Views {
    /// <summary>
    /// Interaction logic for WEmployee1.xaml
    /// </summary>
    public partial class WEmployee1 : Window, INavigatorbar {

        private String dbtable = "WEmployee1";

        ObservableCollection_Employee empl_class = new ObservableCollection_Employee();
        List<ModelEmployee> empl_Items = null;

        String filter = "";

        public WEmployee1(Window owner) {
            InitializeComponent();
            this.Owner = owner;
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
        }
        private void Window_Loaded(Object sender, RoutedEventArgs e) {
            navibar.setDatabaseParent(this, 1);

            empl_class = Dbs_QueriesExecute.getItemsFromEmployees(false);
            empl_Items = empl_class.Items;

            datagrid.ItemsSource = empl_Items;
            setFontsize();
            navibar.setCount(empl_class.Items.Count, empl_class.Items.Count);
            Basis.setWindowPositionFromRegistry(this, Companyregistry.C_REG_ADR + "\\position", "table" + dbtable);
        }

        // Neu: setzen der Schriftgrößen aus CompanyRegistry
        private void setFontsize() {
            int fHeadersize = Companyregistry.HeaderFont;
            int fNormalsize = Companyregistry.NormalFont;
            this.FontSize = fNormalsize;
            labelTitle.FontSize = fHeadersize;
        }

        private void datagrid_MouseDoubleClick(Object sender, MouseButtonEventArgs e) {
            int index = datagrid.SelectedIndex;
            if (index >= 0) {
                ModelEmployee empl = (ModelEmployee)datagrid.SelectedItem;
                    WInputEmployee dialog = new WInputEmployee(this, false, empl);
                    dialog.ShowDialog();
                    if (dialog.Retcode) {
                    datagrid.ItemsSource = null;
                    datagrid.ItemsSource = empl_Items;
                    setFilter(1, this.filter);
                }
            }
        }

        private void datagrid_SelectionChanged(Object sender, SelectionChangedEventArgs e) {
            ModelEmployee employee = (ModelEmployee)datagrid.SelectedItem;
            // labelCountry.Content = employee.Country;
        }


        public void setInsert(Int32 nr) {
            ModelEmployee empl = new ModelEmployee();
            WInputEmployee dialog = new WInputEmployee(this, true, empl);
            dialog.ShowDialog();
            if (dialog.Retcode) {  // ok gedrückt?
                empl_Items.Add(empl);
                setFilter(1, this.filter);
            }
        }

        public void setDelete(Int32 nr) {
            ModelEmployee empl = (ModelEmployee)datagrid.SelectedItem;
            if (empl != null) {
                if (Basis.readYesNo("Wollen Sie wirklich diesen Mitarbeiter löschen ?\r\n" +
                        "Mitarbeiter: " + empl.Lastname + ", " + empl.Firstname + ")", "Mitarbeiter löschen")) {
                    empl_class.Delete(empl);
                    setFilter(1, this.filter);
                }
            }
        }

        private void chkWithGroups_Click(Object sender, RoutedEventArgs e) {
            //datagrid.ItemsSource = null;
            //if (chkWithGroups.IsChecked == true) {
            //    // setDataGridGroup();
            //    datagrid.ItemsSource = empl_Items;
            //    CollectionView view = (CollectionView)CollectionViewSource.GetDefaultView(datagrid.ItemsSource);
            //    PropertyGroupDescription groupDescription = new PropertyGroupDescription("City");
            //    view.GroupDescriptions.Add(groupDescription);

            //}
            //else {
            //    datagrid.ItemsSource = empl_Items;
            //}

        }


        String[] filteritems = null;
        public void setFilter(int nr, String filter) {
            this.filter = filter;
            string[] splitStrings = { ";" };
            filteritems = filter.Split(splitStrings, StringSplitOptions.None);
            int n = 0;
            foreach (ModelEmployee empl in empl_Items) {
                empl.isChecked = true;
                if (filter.Length > 0) {
                    foreach (String item in filteritems) {
                        if (!empl.Lastname.StartsWith(item)) empl.isChecked = false;
                    }
                }
                if (empl.isChecked) {
                    n++;
                }
            }
            datagrid.ItemsSource = from empl in empl_Items
                                   where empl.isChecked
                                   select empl;
            navibar.setCount(n, empl_Items.Count);
        }

        private BackgroundWorker worker = null;

        private void progressing(int runMethodNumber, int anz) {
            progressbar.Maximum = anz + 1;  // caption + n
            worker = new BackgroundWorker();
            worker.WorkerReportsProgress = true;
            worker.ProgressChanged += worker_ProgressChanged;
            switch (runMethodNumber) {
                case 0:
                    worker.DoWork += export2ExcelBiff;
                    break;
                case 1:
                    worker.DoWork += Export2Excel1;
                    break;
                case 2:
                    worker.DoWork += Export2Excel2;
                    break;
                case 3:
                    worker.DoWork += Export2Excel3;
                    break;

                default:
                    Basis.ErrorMsg("Wrong case\r\nNumber: " + runMethodNumber, "progressing");
                    break;
            }
            // save2Access;  // die run-Methode
            worker.RunWorkerAsync();
        } // progressing


        // Wichtig, diese Methode wird nach jeder Änderung aufgerufen.
        // Die Abfrage "istEnde" dient als EndeAktion
        void worker_ProgressChanged(object sender, ProgressChangedEventArgs e) {
            progressbar.Value = e.ProgressPercentage;
            if (e.ProgressPercentage == progressbar.Maximum) {
                progressbar.Value = 0;
                // Basis.Message("Habe fertig", "Export");
            }
        }

        // Thread-Problem
        private int getNumbers2Export() {
            int summe = 0;
            foreach (ModelEmployee empl in empl_Items) {
                if (empl.isChecked) {
                    summe++;
                }
            }
            return summe;
        }
        private void bnExcelBiff_Click(Object sender, RoutedEventArgs e) {
            progressing(0, getNumbers2Export());  // export2ExcelBiff
        }


        // Neu: nun mit StopUhr
        private void bnExcel1_Click(Object sender, RoutedEventArgs e) {
            progressing(1, getNumbers2Export());  // Export2Excel1
        }

        // Neu: nun mit StopUhr
        private void bnExcel2_Click(Object sender, RoutedEventArgs e) {
            progressing(2, getNumbers2Export());  // Export2Excel2
        }

        // Neu: nun mit StopUhr
        private void bnExcel3_Click(Object sender, RoutedEventArgs e) {
            progressing(3, getNumbers2Export());  // Export2Excel2
        }




        private void export2ExcelBiff(object sender, DoWorkEventArgs e) {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Filter = "Excel-Datei (*.xls)|*.xls|All files (*.*)|*.*";
            saveFileDialog1.FilterIndex = 1;// zählt von 1 !
            saveFileDialog1.DefaultExt = ".xls";
            saveFileDialog1.InitialDirectory = Environment.CurrentDirectory;
            if (saveFileDialog1.ShowDialog() == true) {
                String filename = saveFileDialog1.FileName.ToString();
                Export2EXCEL exportexcel = new Export2EXCEL(filename);
                exportexcel.openFile();
                // header
                exportexcel.Write(0, 0, "Nr");
                exportexcel.Write(1, 0, "Vorname");
                exportexcel.Write(2, 0, "Nachname");
                exportexcel.Write(2, 0, "Straße");
                exportexcel.Write(2, 0, "Postleitzahl");
                exportexcel.Write(2, 0, "Stadt");
                exportexcel.Write(2, 0, "Land");
                exportexcel.Write(2, 0, "Gehalt");
                exportexcel.Write(2, 0, "Telefon");
                worker.ReportProgress(1); Thread.Sleep(5);

                int row = 0;
                foreach (ModelEmployee empl in empl_Items) {
                    if (empl.isChecked) {
                        row++;
                        exportexcel.Write(0, row, row);
                        exportexcel.Write(1, row, empl.Firstname);
                        exportexcel.Write(2, row, empl.Lastname);
                        exportexcel.Write(3, row, empl.Street);
                        exportexcel.Write(4, row, empl.Zipcode);
                        exportexcel.Write(5, row, empl.City);
                        exportexcel.Write(6, row, empl.Country);
                        exportexcel.Write(7, row, empl.Monthlysalary);
                        exportexcel.Write(8, row, empl.Mobile);
                        worker.ReportProgress(row + 1);  // Thread.Sleep(5);
                    }
                }

                exportexcel.closeFile();
                Process Prog = new Process();
                Prog.StartInfo.FileName = "excel.exe";
                Prog.StartInfo.Arguments = filename;
                Prog.Start();
            }
        }

        private void Export2Excel1(object sender, DoWorkEventArgs e) {
            var xl = new Excel.Application();
            var wb = xl.Workbooks.Add();
            xl.Visible = true;

            Stopwatch stopWatch = new Stopwatch();
            stopWatch.Start();
            String[] captions = ModelEmployee.CaptionItemArray;
            for (int i = 0; i < captions.Length; i++) {
                xl.Cells[1, i + 1] = captions[i];  // row, column
                xl.Cells[1, i + 1].Select();
                xl.ActiveCell.Font.Size = 12;
                xl.ActiveCell.Font.Bold = true;
            }
            worker.ReportProgress(1); Thread.Sleep(5);

            int row = 2;
            foreach (ModelEmployee empl in empl_Items) {
                if (empl.isChecked) {
                    xl.Cells[row, 1] = (row - 1).ToString();
                    xl.Cells[row, 2] = empl.Firstname;
                    xl.Cells[row, 3] = empl.Lastname;
                    xl.Cells[row, 4] = empl.Monthlysalary;
                    xl.Cells[row, 5] = empl.Yearsalary;
                    xl.Cells[row, 6] = empl.Street;
                    xl.Cells[row, 7] = empl.Zipcode;
                    xl.Cells[row, 8] = empl.City;
                    xl.Cells[row, 9] = empl.Country;
                    xl.Cells[row, 10] = empl.Mobile;
                    worker.ReportProgress(row);  // Thread.Sleep(5);
                    row++;
                }
            }
            stopWatch.Stop();
            TimeSpan ts = stopWatch.Elapsed;
            // Basis.Message("Zeit: " + ts.ToString(), "Excel1");
        }  // bnExport2Excel1_Click  


        private void Export2Excel2(object sender, DoWorkEventArgs e) {
            var xl = new Excel.Application();
            var wb = xl.Workbooks.Add();
            xl.Visible = true;

            var ws = (Excel.Worksheet)wb.ActiveSheet;// neu

            Stopwatch stopWatch = new Stopwatch();
            stopWatch.Start();
            String[] captions = ModelEmployee.CaptionItemArray;
            for (int i = 0; i < captions.Length; i++) {
                xl.Cells[1, i + 1] = captions[i];  // row, column
                xl.Cells[1, i + 1].Select();
                xl.ActiveCell.Font.Size = 12;
                xl.ActiveCell.Font.Bold = true;
            }
            worker.ReportProgress(1); Thread.Sleep(5);

            int row = 0;
            int columnCount = captions.Length;
            foreach (ModelEmployee empl in empl_Items) {
                if (empl.isChecked) {
                    ws.Range["A2"].Offset[row].Resize[1, columnCount].Value = empl.ItemArray(row);
                    worker.ReportProgress(row+2);  // Thread.Sleep(5);
                    row++;
                }
            }
            stopWatch.Stop();
            TimeSpan ts = stopWatch.Elapsed;
            Basis.Message("Zeit: " + ts.ToString(), "Excel2");
        }  // bnExport2Excel2_Click    


        private void Export2Excel3(object sender, DoWorkEventArgs e) {
            var xl = new Excel.Application();
            var wb = xl.Workbooks.Add();
            xl.Visible = true;

            Stopwatch stopWatch = new Stopwatch();
            stopWatch.Start();
            int columnCount = ModelEmployee.CaptionItemArray.Length;
            for (int i = 0; i < columnCount; i++) {
                xl.Cells[1, i + 1] = ModelEmployee.CaptionItemArray[i];
                xl.Cells[1, i + 1].Select();
                xl.ActiveCell.Font.Size = 12;
                xl.ActiveCell.Font.Bold = true;
            }
            worker.ReportProgress(1); Thread.Sleep(5);

            var ws = (Excel.Worksheet)wb.ActiveSheet;
            int index = 0;
            // Spalte A2 und B101 werden als String vordefiniert
            //   Problem: 1.1.20
            ws.Range["A2:B" + (empl_Items.Count + 1)].Select();
            xl.Selection.NumberFormat = "@"; // String
            xl.Cells[1, 1].Select();

            int row = 0;
            int n = 0;
            int MAX = 40;  // Anzahl der "Blockzeilen"
            // erzeuge das Regal "Billy" für Excel
            Object[,] items = new Object[MAX, columnCount];
            int rowOffset = 0;
            foreach (ModelEmployee empl in empl_Items) {
                if (empl.isChecked) {
                    String dummy = empl.Lastname;
                    index++;
                    n++;
                    empl.insertinItemArray(rowOffset, items);
                    rowOffset++;
                    // ist Billy voll ?
                    if (n == MAX) {
                        ws.Range["A2"].Offset[row].Resize[MAX, columnCount].Value
                              = items; // billy wird zugewiesen
                        n = 0;
                        rowOffset = 0;
                        row += MAX;
                    }  // if
                    worker.ReportProgress(n+1);  // Thread.Sleep(5);
                }  // if
            }  // foreach
            if (n > 0) {
                ws.Range["A2"].Offset[row].Resize[MAX, columnCount].Value = items; // billy wird zugewiesen
            }

            stopWatch.Stop();
            TimeSpan ts = stopWatch.Elapsed;
            Basis.Message("Zeit: " + ts.ToString(), "Excel3");
        } // bnExport2Excel3_Click    




        private void bnOk_Click(Object sender, RoutedEventArgs e) {
            Close();
        }

        private void bnCancel_Click(Object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_Closing(Object sender, System.ComponentModel.CancelEventArgs e) {
            Basis.writeWindowPosition2Registry(this, Companyregistry.C_REG_ADR + "\\position", "table" + dbtable);
        }

        

        private void bnChart_Click(Object sender, RoutedEventArgs e) {
            List<ChartStrInt> salaryList = new List<ChartStrInt>();
            salaryList.Add(new ChartStrInt("<=1000", 1000.0m));
            salaryList.Add(new ChartStrInt("<=2000", 2000.0m));
            salaryList.Add(new ChartStrInt("<=3000", 3000.0m));
            salaryList.Add(new ChartStrInt("<=4000", 4000.0m));
            salaryList.Add(new ChartStrInt("<=5000", 5000.0m));
            salaryList.Add(new ChartStrInt("<=6000", 6000.0m));
            salaryList.Add(new ChartStrInt("<=7000", 7000.0m));
            salaryList.Add(new ChartStrInt(">7000", 0.0m));

            ChartStrInt sal;
            foreach (ModelEmployee empl in empl_Items) {
                if (empl.Monthlysalary>7000) {
                    decimal d = empl.Monthlysalary;
                }

                for (int i=0; i<salaryList.Count; i++) {
                    sal = salaryList[i];
                    if (empl.Monthlysalary<= sal.max || sal.max==0) {
                        sal.anz++;
                        break;
                    }
                }
            }            
            (new WChartStringInt(this, "Gehaltsstufen", salaryList)).ShowDialog();

        }
    }
}
