﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;


// 1. Kopieren der 3 Dateien
// 2. Reference Browse: System.Windows.Controls.DataVisualization.Toolkit.dll

using System.Windows.Controls.DataVisualization.Charting;
using Company.Models;



namespace Company.ViewsDialog {
    /// <summary>
    /// Interaction logic for WChartDeptEmployee.xaml
    /// </summary>
    public partial class WChartDeptEmployee : Window {

        private String dbtable = "WChartDeptEmployee";

        private String caption;
        private List<ModelChart> chartliste;

        public WChartDeptEmployee(Window owner, String caption, List<ModelChart> chartliste) {
            InitializeComponent();
            this.Owner = owner;
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
            this.caption = caption;
            this.chartliste = chartliste;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            mcChart.LegendTitle = "Legende";
            mcChart.Title = caption;

            KeyValuePair<String, decimal>[] valueXY =  new KeyValuePair<String, decimal>[chartliste.Count];
            for (int i = 0; i < chartliste.Count; i++) {
                valueXY[i] = new KeyValuePair<String, decimal>(
                     chartliste[i].xValue, chartliste[i].yValue);
            }

            ColumnSeries cs1 = ((ColumnSeries)mcChart.Series[0]);
            cs1.ItemsSource = valueXY;
            Basis.setWindowPositionFromRegistry(this, Companyregistry.C_REG_ADR + "\\position", "table" + dbtable);
        }



        private void bnChart2Clipboard_Click(object sender, RoutedEventArgs e) {
            CopyUIElementToClipboard(mcChart);
        }

        // source: http://elegantcode.com/2010/12/13/wpfcopy-uielement-to-clipboard-as-multiple-formats/
        public static void CopyUIElementToClipboard(FrameworkElement element) {
            //data object to hold our different formats representing the element 
            DataObject dataObject = new DataObject();
            //lets start with the text representation 
            //to make is easy we will just assume the object set as the DataContext has the ToString method overrideen and we use that as the text
            dataObject.SetData(DataFormats.Bitmap, element, true);

            //now lets do the image representation 
            double width = element.ActualWidth;
            double height = element.ActualHeight;
            RenderTargetBitmap bmpCopied = new RenderTargetBitmap((int)Math.Round(width), (int)Math.Round(height), 96, 96, PixelFormats.Default);
            DrawingVisual dv = new DrawingVisual();
            using (DrawingContext dc = dv.RenderOpen()) {
                VisualBrush vb = new VisualBrush(element);
                dc.DrawRectangle(vb, null, new Rect(new Point(), new Size(width, height)));
            }
            bmpCopied.Render(dv);
            dataObject.SetData(DataFormats.Bitmap, bmpCopied, true);

            //now place our object in the clipboard 
            Clipboard.SetDataObject(dataObject, true);
        }

        private void Window_Closing(Object sender, System.ComponentModel.CancelEventArgs e) {
            Basis.writeWindowPosition2Registry(this, Companyregistry.C_REG_ADR + "\\position", "table" + dbtable);
        }
    }
}
