﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using Company.DBS_Klassen;
using Company.Models;
using Company.ViewModels;
using Microsoft.Win32;
using System.Collections.ObjectModel;
using System.IO;
using System.Collections;
using System.Diagnostics;
using System.ComponentModel;
using System.Threading;

namespace Company.ViewsDialog {
    /// <summary>
    /// Interaction logic for WDialogExportXML.xaml
    /// </summary>
    public partial class WDialogExportXMLJSon : Window {

        private String dbtable = "WDialogExportXML";

        List<ModelDept> dept_Items = null;

        List<ModelEmployee> empl_Items = null;


        public WDialogExportXMLJSon(Window owner) {
            InitializeComponent();
            this.Owner = owner;
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;

            this.dept_Items = Dbs_QueriesExecute.getItemsFromDept().Items;

            this.empl_Items = Dbs_QueriesExecute.getItemsFromEmployees(false).Items;            

        }

        private void Window_Loaded(Object sender, RoutedEventArgs e) {
            foreach (ModelDept dept in dept_Items) {
                CheckBox chkBoxDept = new CheckBox();
                chkBoxDept.Tag = dept;
                chkBoxDept.Content = dept;
                chkBoxDept.Click += new RoutedEventHandler(chkBoxDept_Click);  // labelCount
                listbox.Items.Add(chkBoxDept);
            }

            setFontsize();
            Basis.setWindowPositionFromRegistry(this, Companyregistry.C_REG_ADR + "\\position", "table" + dbtable);
        }

        private void chkBoxDept_Click(object sender, RoutedEventArgs e) {
            listboxSelect.Items.Clear();
            int summe = 0;
            foreach (CheckBox chk in listbox.Items) {
                if (chk.IsChecked == true) {
                    listboxSelect.Items.Add(chk.Content);
                    summe++;
                }
            }
            labelCount.Content = summe + " Abteilungen";
        }


        // Neu: setzen der Schriftgrößen aus CompanyRegistry
        private void setFontsize() {
            int fHeadersize = Companyregistry.HeaderFont;
            int fNormalsize = Companyregistry.NormalFont;
            this.FontSize = fNormalsize;
            labelTitle.FontSize = fHeadersize;
        }

        private void MnSelectAll_Click(Object sender, RoutedEventArgs e) {
            foreach (CheckBox chk in listbox.Items) {
                chk.IsChecked = true;
            }
            chkBoxDept_Click(null, null);
        }

        private void MnSelectNone_Click(Object sender, RoutedEventArgs e) {
            foreach (CheckBox chk in listbox.Items) {
                chk.IsChecked = false;
            }
            chkBoxDept_Click(null, null);
        }

        private void MnSelectInvers_Click(Object sender, RoutedEventArgs e) {
            foreach (CheckBox chk in listbox.Items) {
                chk.IsChecked = !chk.IsChecked;
            }
            chkBoxDept_Click(null, null);
        }


        private void bnXML1_Click(Object sender, RoutedEventArgs e) {
            SaveFileDialog savefiledialog = new SaveFileDialog();
            savefiledialog.Title = "Export in eine XML-Datei";
            savefiledialog.Filter = "XML-Dateien (*.xml)|*.xml|Alle Dateien|*.*";
            savefiledialog.DefaultExt = ".xml";
            savefiledialog.FilterIndex = 1; // zählt von 1
            savefiledialog.InitialDirectory = Environment.CurrentDirectory;
            if (savefiledialog.ShowDialog() == true) {
                xmlfilename = savefiledialog.FileName;
                int anz = 0;
                hashDeptIndizes.Clear();
                ModelDept dept;
                foreach (CheckBox chk in listbox.Items) {
                    if (chk.IsChecked == true) {
                        dept = (ModelDept)chk.Tag;
                        // listDeptIndizes.Add(dept.Pindex);
                        hashDeptIndizes.Add(dept.Pindex, dept);
                        anz++;
                    }
                }
                anz = dept_Items.Count + empl_Items.Count;
                progressing(1, anz);
            }
        }



        private void bnXML2_Click(Object sender, RoutedEventArgs e) {
            SaveFileDialog savefiledialog = new SaveFileDialog();
            savefiledialog.Title = "Export in eine XML-Datei";
            savefiledialog.Filter = "XML-Dateien (*.xml)|*.xml|Alle Dateien|*.*";
            savefiledialog.DefaultExt = ".xml";
            savefiledialog.FilterIndex = 1; // zählt von 1
            savefiledialog.InitialDirectory = Environment.CurrentDirectory;
            if (savefiledialog.ShowDialog() == true) {
                xmlfilename = savefiledialog.FileName;
                int anz = 0;
                hashDeptIndizes.Clear();
                ModelDept dept;
                foreach (CheckBox chk in listbox.Items) {
                    if (chk.IsChecked == true) {
                        dept = (ModelDept)chk.Tag;
                        // listDeptIndizes.Add(dept.Pindex);
                        hashDeptIndizes.Add(dept.Pindex, dept);
                        anz++;
                    }
                }
                progressing(2, anz);
            }
        }

        private BackgroundWorker worker = null;
        private Hashtable hashDeptIndizes = new Hashtable();
        private String xmlfilename = "";

        private void progressing(int runMethodNumber, int anz) {
            progressbar.Maximum = anz;  
            worker = new BackgroundWorker();
            worker.WorkerReportsProgress = true;
            worker.ProgressChanged += worker_ProgressChanged;
            switch (runMethodNumber) {
                case 1:
                    worker.DoWork += xml1;
                    break;
                case 2:
                    worker.DoWork += xml2;
                    break;
                default:
                    Basis.ErrorMsg("Wrong case\r\nNumber: " + runMethodNumber, "progressing");
                    break;
            }
            // save2Access;  // die run-Methode
            worker.RunWorkerAsync();
        } // progressing



        // Wichtig, diese Methode wird nach jeder Änderung aufgerufen.
        // Die Abfrage "istEnde" dient als EndeAktion
        void worker_ProgressChanged(object sender, ProgressChangedEventArgs e) {
            progressbar.Value = e.ProgressPercentage;
            if (e.ProgressPercentage == progressbar.Maximum) {
                progressbar.Value = 0;
                // Basis.Message("Habe fertig", "Export");
            }
        }

        private void xml1(object sender, DoWorkEventArgs e) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            sb.AppendLine("<Company  xsi:noNamespaceSchemaLocation=\"firma.xsd\"");
            sb.AppendLine("xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">");

            int n = 0;
            ModelDept dept;
            sb.AppendLine("<Departments>");
            foreach (ModelDept deptloop in dept_Items) {
                dept = (ModelDept)hashDeptIndizes[deptloop.Pindex];
                if (dept != null) {
                    dept.save2Xml(sb);                    
                }
                worker.ReportProgress(++n); Thread.Sleep(1);
            }
            sb.AppendLine("</Departments>");

            sb.AppendLine("<Employees>");
            foreach (ModelEmployee empl in empl_Items) {
                dept = (ModelDept)hashDeptIndizes[empl.Deptindex];
                if (dept != null) {
                    empl.save2Xml(sb);
                }
                worker.ReportProgress(++n); Thread.Sleep(1);
            }
            sb.AppendLine("</Employees>");

            sb.AppendLine("</Company>");

            File.WriteAllText(xmlfilename, sb.ToString());
            String xsdFilename = Basis.changeExtension(xmlfilename, ".xsd");
            writeXSDFile1(xsdFilename);

            Process Prog = new Process();
            Prog.StartInfo.FileName = "notepad.exe";
            Prog.StartInfo.Arguments = xmlfilename;
            Prog.Start();
        }

        private void xml2(object sender, DoWorkEventArgs e) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            sb.AppendLine("<Company  xsi:noNamespaceSchemaLocation=\"firma.xsd\"");
            sb.AppendLine("xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">");

            int n = 0;
            ModelDept dept;
            sb.AppendLine("<Departments>");
            foreach (ModelDept deptloop in dept_Items) {
                dept = (ModelDept)hashDeptIndizes[deptloop.Pindex];
                if (dept != null) {
                    dept.save2Xml(sb,false);

                    bool first = true;
                    // sb.AppendLine("<Employees>");
                    foreach (ModelEmployee empl in empl_Items) {
                        if (dept.Pindex == empl.Deptindex) {
                            if (first) {
                                sb.AppendLine("    <Employees>");
                                first = false;
                            }
                            empl.save2Xml(sb);
                        }
                    }
                    if (!first) {
                        sb.AppendLine("    </Employees>");
                    }
                    sb.AppendLine("  </Department>");
                    worker.ReportProgress(++n); Thread.Sleep(1);
                }
            }
            sb.AppendLine("</Departments>");
            sb.AppendLine("</Company>");

            File.WriteAllText(xmlfilename, sb.ToString());
            String xsdFilename = Basis.changeExtension(xmlfilename, ".xsd");
            writeXSDFile2(xsdFilename);

            Process Prog = new Process();
            Prog.StartInfo.FileName = "notepad.exe";
            Prog.StartInfo.Arguments = xmlfilename;
            Prog.Start();
        }  // xml2


        private void writeXSDFile1(String filename) {
            StringBuilder sb = new StringBuilder();

            sb.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            sb.AppendLine("<xsd:schema xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">");
            sb.AppendLine("");
            sb.AppendLine("<xsd:element name=\"Company\">");
            sb.AppendLine("");
            sb.AppendLine("<xsd:complexType>");
            sb.AppendLine("  <xsd:sequence>");
            sb.AppendLine("    <xsd:element name=\"Departments\" type=\"DepartmentsType\"/>");
            sb.AppendLine("    <xsd:element name=\"Employees\" type=\"EmployeesType\"/>");
            sb.AppendLine("  </xsd:sequence>");
            sb.AppendLine("</xsd:complexType>");
            sb.AppendLine("</xsd:element>");
            sb.AppendLine("");
            sb.AppendLine("");
            sb.AppendLine("");
            sb.AppendLine("<xsd:complexType name=\"DepartmentsType\">");
            sb.AppendLine("  <xsd:sequence>");
            sb.AppendLine("   <xsd:element name=\"Department\" type=\"DepartmentType\" maxOccurs=\"unbounded\" />");
            sb.AppendLine("  </xsd:sequence>");
            sb.AppendLine("</xsd:complexType>");
            sb.AppendLine("");
            sb.AppendLine("<xsd:complexType name=\"EmployeesType\">");
            sb.AppendLine("  <xsd:sequence>");
            sb.AppendLine("   <xsd:element name=\"Employee\" type=\"EmployeeType\" maxOccurs=\"unbounded\" />");
            sb.AppendLine("  </xsd:sequence>");
            sb.AppendLine("</xsd:complexType>");
            sb.AppendLine("");
            sb.AppendLine("<xsd:complexType name=\"DepartmentType\">");
            sb.AppendLine("  <xsd:sequence>");
            sb.AppendLine("   <xsd:element name=\"Pindex\" type=\"xsd:int\" />");
            sb.AppendLine("   <xsd:element name=\"City\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Country\" type=\"xsd:string\" />");
            sb.AppendLine("  </xsd:sequence>");
            sb.AppendLine("</xsd:complexType>");
            sb.AppendLine("");
            sb.AppendLine("<xsd:complexType name=\"EmployeeType\">");
            sb.AppendLine("  <xsd:sequence>");
            sb.AppendLine("   <xsd:element name=\"Pindex\" type=\"xsd:int\" />");
            sb.AppendLine("   <xsd:element name=\"Firstname\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Lastname\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Monthlysalary\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Street\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Zipcode\" type=\"xsd:int\" />");
            sb.AppendLine("   <xsd:element name=\"City\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Country\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Mobile\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Remark\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Deptindex\" type=\"xsd:int\" />");
            sb.AppendLine("  </xsd:sequence>");
            sb.AppendLine("</xsd:complexType>");
            sb.AppendLine("");
            sb.AppendLine("</xsd:schema>");

            File.WriteAllText(filename, sb.ToString());

        }  // writeXSDFile1


        private void writeXSDFile2(String filename) {
            StringBuilder sb = new StringBuilder();

            sb.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            sb.AppendLine("<xsd:schema xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">");
            sb.AppendLine("");
            sb.AppendLine("<xsd:element name=\"Company\">");
            sb.AppendLine("");
            sb.AppendLine("<xsd:complexType>");
            sb.AppendLine("  <xsd:sequence>");
            sb.AppendLine("    <xsd:element name=\"Departments\" type=\"DepartmentsType\"/>");
            sb.AppendLine("  </xsd:sequence>");
            sb.AppendLine("</xsd:complexType>");
            sb.AppendLine("</xsd:element>");
            sb.AppendLine("");
            sb.AppendLine("<xsd:complexType name=\"DepartmentsType\">");
            sb.AppendLine("  <xsd:sequence>");
            sb.AppendLine("   <xsd:element name=\"Department\" type=\"DepartmentType\" maxOccurs=\"unbounded\" />");
            sb.AppendLine("  </xsd:sequence>");
            sb.AppendLine("</xsd:complexType>");
            sb.AppendLine("");
            sb.AppendLine("<xsd:complexType name=\"DepartmentType\">");
            sb.AppendLine("  <xsd:sequence>");
            sb.AppendLine("   <xsd:element name=\"Pindex\" type=\"xsd:int\" />");
            sb.AppendLine("   <xsd:element name=\"City\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Country\" type=\"xsd:string\" />");
            sb.AppendLine("    <xsd:element name=\"Employees\" type=\"EmployeesType\"/>");
            sb.AppendLine("  </xsd:sequence>");
            sb.AppendLine("</xsd:complexType>");
            sb.AppendLine("");
            sb.AppendLine("<xsd:complexType name=\"EmployeesType\">");
            sb.AppendLine("  <xsd:sequence>");
            sb.AppendLine("   <xsd:element name=\"Employee\" type=\"EmployeeType\" maxOccurs=\"unbounded\" />");
            sb.AppendLine("  </xsd:sequence>");
            sb.AppendLine("</xsd:complexType>");
            sb.AppendLine("");
            sb.AppendLine("<xsd:complexType name=\"EmployeeType\">");
            sb.AppendLine("  <xsd:sequence>");
            sb.AppendLine("   <xsd:element name=\"Pindex\" type=\"xsd:int\" />");
            sb.AppendLine("   <xsd:element name=\"Firstname\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Lastname\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Monthlysalary\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Street\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Zipcode\" type=\"xsd:int\" />");
            sb.AppendLine("   <xsd:element name=\"City\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Country\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Mobile\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Remark\" type=\"xsd:string\" />");
            sb.AppendLine("   <xsd:element name=\"Deptindex\" type=\"xsd:int\" />");
            sb.AppendLine("  </xsd:sequence>");
            sb.AppendLine("</xsd:complexType>");
            sb.AppendLine("");
            sb.AppendLine("");
            sb.AppendLine("");
            sb.AppendLine("</xsd:schema>");

            File.WriteAllText(filename, sb.ToString());

        }  // writeXSDFile2

        private void bnJSon_Click(Object sender, RoutedEventArgs e) {

        }


        private void bnEsc_Click(Object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_KeyDown(Object sender, KeyEventArgs e) {

        }

        private void Window_Closing(Object sender, System.ComponentModel.CancelEventArgs e) {
            Basis.writeWindowPosition2Registry(this, Companyregistry.C_REG_ADR + "\\position", "table" + dbtable);
        }

    }
}
