﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using Microsoft.Win32;
using System.IO;
using System.Xml;
using System.Xml.Linq;
using Company.Models;

namespace Company.ViewsDialog {
    /// <summary>
    /// Interaction logic for WDialogImportXML.xaml
    /// </summary>
    public partial class WDialogImportXML : Window {
        public WDialogImportXML(Window owner) {
            InitializeComponent();
            this.Owner = owner;
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
        }

        private void Window_Loaded(Object sender, RoutedEventArgs e) {
            setFontsize();
        }

        // Neu: setzen der Schriftgrößen aus CompanyRegistry
        private void setFontsize() {
            int fHeadersize = Companyregistry.HeaderFont;
            int fNormalsize = Companyregistry.NormalFont;
            this.FontSize = fNormalsize;
            labelTitle.FontSize = fHeadersize;
        }

        private void bnOpenfile_Click(Object sender, RoutedEventArgs e) {
            OpenFileDialog openfiledialog = new OpenFileDialog();
            openfiledialog.Filter = "XML (*.xml)|*.xml|Alle Dateien|*.*";
            openfiledialog.DefaultExt = ".xml";
            openfiledialog.FilterIndex = 1; // zählt von 1
            openfiledialog.InitialDirectory =
                Environment.CurrentDirectory;
            if (openfiledialog.ShowDialog() == true) {
                tFilename.Text = openfiledialog.FileName;
            }
        }  // bnOpenfile_Click


        private void bnOk_Click(Object sender, RoutedEventArgs e) {
            // laden xml-Datei
            String filename = tFilename.Text.Trim();
            if (!File.Exists(filename)) {
                Basis.ErrorMsg("Die Datei existiert nicht\r\n" + tFilename.Text, "Hinweis");
                return;
            }
            StringBuilder sb = new StringBuilder();
            XmlDocument doc = new XmlDocument();
            doc.Load(filename);
            XmlNode node = doc.DocumentElement.SelectSingleNode("/Company/Departments");
            sb.AppendLine(node.Name);  // InnerText
            foreach (XmlNode node2 in node.ChildNodes) {
                sb.Append("  ");
                sb.AppendLine(node2.Name);  // Innertext
                sb.Append("  ");
                sb.AppendLine(node2.Value);  // 
                sb.Append("  ");
                sb.AppendLine(node2.ChildNodes.Count.ToString());  // 3:  city,country, employees
                sb.AppendLine("  City: " + node2.ChildNodes[0].InnerText);
                sb.AppendLine("  Country: " + node2.ChildNodes[1].InnerText);
                List<ModelEmployee> listeEmployee = readEmployee(node2.ChildNodes[2]);
                foreach(ModelEmployee empl in listeEmployee) {
                    sb.Append("  ");
                    sb.AppendLine(empl.ToString());  // 

                }
                sb.AppendLine();
                sb.AppendLine();
            }
            sb.AppendLine();
            sb.AppendLine();

            //var xml = XDocument.Load(filename);
            //// Query the data and write out a subset of contacts
            //var query = from c in xml.Root.Descendants("/Company/Departments")
            ////where (int)c.Attribute("id") < 4
            //select c.Element("City").Value + " " + c.Element("Country").Value;


            //foreach (string name in query) {
            //    sb.Append("  ");
            //    sb.Append("  ");
            //    sb.AppendLine(name);
            //}
            editor.Text = sb.ToString();

        }  // bnOk_Click

        private List<ModelEmployee> readEmployee(XmlNode nodeEmployees) {
            // Employees
            List<ModelEmployee> liste = new List<ModelEmployee>();
            ModelEmployee empl;
            decimal decvalue;
            String dummy;
            foreach (XmlNode node in nodeEmployees.ChildNodes) {
                //sb.Append("  ");
                //sb.AppendLine(node.Name); // Employee
                empl = new ModelEmployee();
                empl.Firstname = node.ChildNodes[0].InnerText;
                empl.Lastname = node.ChildNodes[1].InnerText;
                dummy = node.ChildNodes[2].InnerText;
                if (Check.tryDecimal(dummy,out decvalue)) {
                    empl.Monthlysalary = decvalue;
                }
                
                empl.Street = node.ChildNodes[3].InnerText;
                empl.Zipcode = node.ChildNodes[4].InnerText;
                empl.City = node.ChildNodes[5].InnerText;
                empl.Mobile = node.ChildNodes[6].InnerText;
                empl.Rem = node.ChildNodes[7].InnerText;
                liste.Add(empl);
            }

            return liste;
        }  // readEmployee


        //  // Query the data and write out a subset of contacts
        //var query = from c in xml.Root.Descendants("contact")
        //            where (int)c.Attribute("id") < 4
        //            select c.Element("firstName").Value + " " +
        //                   c.Element("lastName").Value;


        //foreach (string name in query)
        //{
        //    Console.WriteLine("Contact's Full Name: {0}", name);
        //}


        private void bnEsc_Click(Object sender, RoutedEventArgs e) {
            Close();
        }


        private void Window_KeyDown(Object sender, KeyEventArgs e) {

        }

        private void Window_Closing(Object sender, System.ComponentModel.CancelEventArgs e) {

        }

    }
}
