﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using System.IO;
using System.Threading;
using System.Windows.Threading;
using Company.DBS_Klassen;
using System.ComponentModel;

namespace Company.ViewsDialog {
    /// <summary>
    /// Interaction logic for WProgressBarCreateTables.xaml
    /// </summary>
    public partial class WProgressBarCreateTables : Window {

        String[] sql_commands;
        Dbs dbs = Dbs.getInstance();
        private String sqlfilename;

        private bool canClose = true;


        public WProgressBarCreateTables(Window parent, String sqlfilename) {
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner      
            this.WindowStartupLocation = System.Windows.WindowStartupLocation.CenterOwner;
            this.sqlfilename = sqlfilename;

        }
        private void Window_Loaded(object sender, RoutedEventArgs e) {
            // einlesen der SQL-Anweisungen
            try {
                // String sSQL = File.ReadAllText(sqlfilename, System.Text.Encoding.UTF7);
                //String sSQL = File.ReadAllText(sqlfilename, Encoding.GetEncoding(437));
                String sSQL = File.ReadAllText(sqlfilename, System.Text.Encoding.UTF7);
                // Splitten durch das Semikolon
                sql_commands = sSQL.Split(new Char[] { ';' });
                // Setzen der Progressbar
                progressbar.Maximum = sql_commands.Length;
                progressbar.Minimum = 0;

                progressbar.Maximum = sql_commands.Length;
                worker = new BackgroundWorker();
                worker.WorkerReportsProgress = true;
                worker.ProgressChanged += worker_ProgressChanged;
                worker.DoWork += insertTables;  // die run-Methode
                worker.RunWorkerAsync();
            }
            catch (Exception ex) {
                Basis.ErrorMsg("Fehler beim Öffnen der SQL-Datei\r\n" + ex.ToString(), "Fehler beim ERzeugen der Datenbank");
            }
        }

        // neuerCode:  woher mit Threads
        private BackgroundWorker worker = null;

        // Wichtig, diese Methode wird nach jeder Änderung aufgerufen.
        // Die Abfrage "istEnde" dient als EndeAktion
        void worker_ProgressChanged(object sender, ProgressChangedEventArgs e) {
            progressbar.Value = e.ProgressPercentage;
            if (e.ProgressPercentage == progressbar.Maximum) {
                progressbar.Value = 0;
                Basis.Message("Habe fertig", "Erzeugen der Datenbank");
            }
            else {
                labelProgress.Content = "Verlauf: " + (progressbar.Value * 100.0 / progressbar.Maximum).ToString("0.0") + " %";
            }
        }

        // run-Methode
        private void insertTables(object sender, DoWorkEventArgs e) {
            int i = 0;
            foreach (String sql in sql_commands) {
                i++;
                if ((i % 10) == 0) {
                    worker.ReportProgress(i); Thread.Sleep(5);
                }
                if (sql.Trim().Length > 0) {
                    dbs.selectDBS(sql);
                }
            }
            Basis.Message("Die Datenbank wurde erzeugt", "Hinweis");
            canClose = false;
        }


        private void bnOk_Click(object sender, RoutedEventArgs e) {
            Close();
        }



        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
            e.Cancel = canClose;   // bei false kann man schliessen
        }

    }
}

