﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using Company.Models;
using Company.ViewModels;
using Company.DBS_Klassen;

namespace Company.ViewsDialog {
    /// <summary>
    /// Interaction logic for WInputEmployee.xaml
    /// </summary>
    public partial class WInputEmployee : Window {

        private bool newEmpl;

        private ObservableCollection_Dept listAbt;


        private ModelEmployee empl = null;
        private bool retcode = false;
        public bool Retcode {
            get { return retcode; }
        }


        public WInputEmployee(Window owner, bool newEmpl, ref ModelEmployee empl) {
            InitializeComponent();
            this.Owner = owner;
            this.WindowStartupLocation = 
                WindowStartupLocation.CenterOwner;
            this.empl = empl;
            this.newEmpl = newEmpl;
        }  

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            if (newEmpl) {
                lbdept.Content = "Einfügen eines neuen Mitarbeiters";
            }
            else {
                lbdept.Content = "Ändern der Daten eines Mitarbeiters";
            }
            tFirstname.Text = empl.Firstname;
            tLastname.Text = empl.Lastname;
            tStreet.Text = empl.Street;
            tZipcode.Text = empl.Zipcode;
            tCity.Text = empl.City;
            tCountry.Text = empl.Country;
            tMobile.Text = empl.Mobile;
            tMonthlysalary.Text =
                empl.Monthlysalary.ToString("#0.00");

            tFirstname.Focus();

            listAbt = Dbs_QueriesExecute.getItemsFromDept();
            cbDepartment.Items.Clear();
            foreach (ModelDept abt in listAbt.Items) {
                cbDepartment.Items.Add(abt);
            }
            cbDepartment.SelectedIndex = -1;
            for (int i = 0; i < listAbt.Items.Count; i++) {
                ModelDept abt2 = listAbt.Items[i];
                if (abt2.Pindex == empl.Deptindex) {
                    cbDepartment.SelectedIndex = i;
                    break;
                }
            }

        }// win loaded

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            if (tFirstname.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte einen Vorname ein", "Hinweis");
                tFirstname.Focus();
                return;
            }
            if (tLastname.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte einen Nachnamen ein", "Hinweis");
                tLastname.Focus();
                return;
            }
            if (tStreet.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte eine Straße ein", "Hinweis");
                tStreet.Focus();
                return;
            }
            if (tZipcode.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte eine Postleitzahl ein", "Hinweis");
                tZipcode.Focus();
                return;
            }
            if (tCity.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte eine Stadt ein", "Hinweis");
                tCity.Focus();
                return;
            }
            if (tCountry.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte eine Land ein", "Hinweis");
                tCountry.Focus();
                return;
            }
            if (tMobile.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte eine Telefonnummer ein", "Hinweis");
                tMobile.Focus();
                return;
            }
            decimal salary;
            String sSalary = 
            tMonthlysalary.Text.Trim().Replace('.', ',');
            if (sSalary.Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte ein monatliches Gehalt ein", "Hinweis");
                tMonthlysalary.Focus();
                return;
            }
            if (!Decimal.TryParse(sSalary, out salary)) {
                Basis.ErrorMsg("Geben Sie bitte ein numerisches monatliches Gehalt ein", "Hinweis");
                tMonthlysalary.Focus();
                return;
            }
            if (salary < 400.0m) {
                Basis.ErrorMsg("Geben Sie bitte ein numerisches monatliches Gehalt ein\r\nMindestgehalt: 400,00 EUR", "Hinweis");
                tMonthlysalary.Focus();
                return;
            }
            if (cbDepartment.SelectedIndex < 0) {
                Basis.ErrorMsg("Geben wählen Sie eine Abteilung aus", "Hinweis");
                cbDepartment.Focus();
                return;
            }
            int deptindex = listAbt.Items[cbDepartment.SelectedIndex].Pindex;

            empl.Firstname = tFirstname.Text.Trim();
            empl.Lastname = tLastname.Text.Trim();
            empl.Street = tStreet.Text.Trim();
            empl.Zipcode = tZipcode.Text.Trim();
            empl.City = tCity.Text.Trim();
            empl.Country = tCountry.Text.Trim();
            empl.Monthlysalary = salary;
            empl.Mobile = tMobile.Text.Trim();
            empl.Deptindex = deptindex;
            retcode = true;

            Close();


        }
        private void bnEsc_Click(object sender,
               RoutedEventArgs e) {
            Close();
        }

    }
}
