﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


using System.IO;
using System.Data.OleDb;
using System.Data;

// Referenz ADOX
// COM  Microsoft   Search ADO, Version 2.8  oder 6.0

namespace Company_Vorlesung.DBS_Klassen {
    public class Dbs {

        private static Dbs dbs = new Dbs();

        private String filename = "";

        public static Dbs getDbsInstance() {
            return dbs;
        }

        private Dbs() {
        }

        public void setDbs(string sDatabaseFile) {
            this.filename = sDatabaseFile;
            if (!File.Exists(filename)) {
                Basis.ErrorMsg("Die Datenbank ist nicht vorhanden\r\n" + filename, "Hinweis");
            }
        }


        public void close() {
            filename = "";

        }

        // ' NOTE: to use ADOX add reference to "COM Microsoft ADO Ext. 2.8 for DDL and Security"!
        // Register    COM  Tpye Library, suchen ADO
        public bool createDatabase(string filename) {
            try {
                if (File.Exists(filename)) {
                    File.Delete(filename);
                }
                this.filename = filename;
                ADOX.Catalog cat = new ADOX.Catalog();
                // ="Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\folder;Extended Properties=dBASE IV;User ID=Admin;Password=;"
                cat.Create("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + filename);
                cat = null;
                return true;
            }
            catch (Exception e) {
                Basis.ErrorMsg("Datenbankfehler: " + e.ToString(), "Fehler");
                return false;
            }
        }

        public void changeDBS(string sql) {
            // Access 2010 :  Provider=Microsoft.ACE.OLEDB.12.0
            try {
                OleDbConnection con = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + filename);
                con.Open();

                OleDbCommand CmdSql;
                if (sql.Trim().Length > 0) {
                    CmdSql = new OleDbCommand(sql, con);
                    // CmdSql = new OleDbCommand();
                    // CmdSql.CommandType = CommandType.Text;
                    // CmdSql.CommandText = @sql;
                    // CmdSql.Connection = con;

                    CmdSql.ExecuteNonQuery();
                }
                con.Close();
            }
            catch (Exception e) {
                Basis.ErrorMsg("Datenbankfehler mit Anweisung: \r\n" + sql + "\r\n\r\n" + e.ToString(), "Fehler");
            }
        }

        public DataTable selectDBS(string sql) {
            DataTable dt = new DataTable();
            try {
                // Access 2010 :  Provider=Microsoft.ACE.OLEDB.12.0
                OleDbConnection con = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + filename);
                con.Open();
                OleDbDataAdapter adapter = new OleDbDataAdapter(sql, con);
                adapter.Fill(dt);
                con.Close();
            }

            catch (Exception e) {
                Basis.ErrorMsg("Datenbankfehler mit Anweisung: \r\n" + sql + "\r\n\r\n" + e.ToString(), "Fehler");
            }

            return dt;
        }

        public List<string> getTables() {
            // Access 2010 :  Provider=Microsoft.ACE.OLEDB.12.0
            OleDbConnection con = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + filename);
            con.Open();
            //DataTable dataTable = con.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, new object[] { null, null, null, null });
            DataTable dataTable = con.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, new object[] { null, null, null, "TABLE" });
            List<string> tables = new List<string>();
            for (int i = 0; i < dataTable.Rows.Count; i++)
                if (dataTable.Rows[i]["TABLE_TYPE"].ToString() == "TABLE")
                    tables.Add(dataTable.Rows[i]["TABLE_NAME"].ToString());
            con.Close();
            return tables;
        }

        public List<string> GetFields(string tableName) {
            OleDbConnection con = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + filename);
            con.Open();

            DataTable dtField = con.GetOleDbSchemaTable(OleDbSchemaGuid.Columns, new object[] { null, null, tableName });
            List<string> tables = new List<string>();
            foreach (DataRow dr in dtField.Rows) {
                // tables.Add(dr["COLUMN_NAME"].ToString() + "   " + dr["COLUMN_NAME"].ToString());
                string fieldname = dr["COLUMN_NAME"].ToString();
                string datatype = "";
                switch ((int)dr["DATA_TYPE"]) {
                    case 3: datatype = "ganzzahlig"; break;
                    case 5: datatype = "Nachkommazahl"; break;
                    case 6: datatype = "Währung"; break;
                    case 7: datatype = "Datum/Zeit"; break;
                    case 11: datatype = "boolean, bit"; break;
                    case 128: datatype = "Binary"; break;
                    case 130: datatype = "Text"; break;
                    case 131: datatype = "Numerik, Decimal"; break;
                    default: datatype = "unbekannt: " + (int)dr["DATA_TYPE"]; break;
                }
                tables.Add(fieldname + "\t(" + datatype + ")");
            }
            return tables;
        }

        public DataTable getDataTyps(string sTable) {
            return null;
        }


    }
}
