﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Company_Vorlesung.MyMessageBox {
    /// <summary>
    /// Interaction logic for WMessageBoxEditor.xaml
    /// </summary>
    public partial class WMessageBoxEditor : Window {

        private String dbtable = "MessageBoxEditor";

        private bool retcode = false;


        public bool Retcode {
            get { return retcode; }
        }



        public String Input {
            get { return tInput.Text.Trim(); }
        }

        public WMessageBoxEditor(Window owner, String labelTitel, String label, String text) {
            InitializeComponent();

            Basis.setWindowPositionFromRegistryWidthHeight(this, InstallRegistry.C_REG_ADR + "\\position", "dialog" + dbtable);
            this.Owner = owner;  // Important, because CenterOwner           
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
            Title = labelTitel;
            this.labelTitel.Content = label;
            tInput.Text = text;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            tInput.Focus();
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            retcode = true;
            Close();
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                e.Handled = true;
                bnOk_Click(sender, e);
            }
            if (Keyboard.IsKeyDown(Key.Escape)) {
                e.Handled = true;
                bnEsc_Click(sender, e);
            }
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
            e.Cancel = false;
            Basis.writeWindowPosition2Registry(this, InstallRegistry.C_REG_ADR + "\\position", "dialog" + dbtable);
        }
    }
}
