﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using System.Windows.Threading;
using System.ComponentModel;  // BackgroundWorker
using System.Threading;
using Install_Main.DBS_Klassen;

namespace Install_Main {
    /// <summary>
    /// Interaction logic for FLoadUpdate.xaml
    /// </summary>
    public partial class WLoadUpdate : Window {

        private String dbtable = "LoadUpdate";

        private BackgroundWorker worker = null;

        private DispatcherTimer dispatcherTimer = new DispatcherTimer();
        private int dbversion = 0;
        private int version = 0;
        private int maxversion = 0;

        public WLoadUpdate(Window owner) {
            InitializeComponent();
            this.Owner = owner;  // Important, because CenterOwner           
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner;
            Basis.setWindowPositionFromRegistryWidthHeight(this, InstallRegistry.C_REG_ADR + "\\position", "dialog" + dbtable);
            this.Topmost = true;
            dbversion = InstallRegistry.DbVersion;
            maxversion = UpdateSQL.AnzSQL;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            dbversion = InstallRegistry.DbVersion;
            version = InstallRegistry.DbVersion;

            dispatcherTimer.Tick += new EventHandler(dispatcherTimer_Tick);
            dispatcherTimer.Interval = TimeSpan.FromMilliseconds(100);
            dispatcherTimer.Start();
        }


        private void dispatcherTimer_Tick(object sender, EventArgs e) {
            // kiesendahl
            CommandManager.InvalidateRequerySuggested();
            dispatcherTimer.Stop();

            version++;

            progressbar2.Visibility = Visibility.Visible;
            progressbar2.IsIndeterminate = true;

            progressbar.Visibility = Visibility.Visible;
            progressbar.Maximum = maxversion - dbversion;
            progressbar.Value = 0;
            indexProgressbar = 0;
            abbruch = false;
            labelProgressbar.Content = "Installieren des " + version + ".Updates";

            worker = new BackgroundWorker();
            worker.WorkerReportsProgress = true;
            worker.DoWork += loadUpdateAction;
            worker.ProgressChanged += worker_ProgressChanged;
            worker.RunWorkerAsync();
        }


        bool abbruch = false;
        int indexProgressbar = 0;
        void worker_ProgressChanged(object sender, ProgressChangedEventArgs e) {
            progressbar.Value = e.ProgressPercentage;
            if (e.ProgressPercentage == progressbar.Maximum || abbruch) {
                progressbar.Value = 0;
                labelProgressbar.Visibility = Visibility.Collapsed;
                progressbar.Visibility = Visibility.Collapsed;
                progressbar2.IsIndeterminate = false;
                progressbar2.Visibility = Visibility.Collapsed;

                InstallRegistry.DbVersion = maxversion;
                Dbs dbs = Dbs.getDbsInstance();
                String sql = "UPDATE " + "DBVERSION " + " " +
                     "SET dbVersion=" + InstallRegistry.DbVersion + ";";
                dbs.changeDBS(sql);

                labelTitel.Content = "Die SQL-Updates wurden erfolgreich eingespielt.";
                labelMessage.Content = "Aktuelle Version: " + InstallRegistry.DbVersion;

                wrappanel.Visibility = Visibility.Visible;
                labelMessage.Visibility = Visibility.Visible;


            }
            else {
                labelProgressbar.Content = "Installieren des " + version + ".Updates";
            }
        }


        private void loadUpdateAction(object sender, DoWorkEventArgs e) {
            // hier werden die Updaten eingetragen

            String mainsql = "";
            Dbs dbs = Dbs.getDbsInstance();
            for (int i = dbversion + 1; i <= maxversion; i++) {
                mainsql = UpdateSQL.getSQL(i);
                if (mainsql.Trim().Length > 0) {
                    String[] sql_commands = mainsql.Split(new Char[] { ';' });
                    foreach (String sql in sql_commands) {
                        if (sql.Trim().Length > 0) {
                            dbs.changeDBS(sql);
                        }
                    }
                }
                UpdateSQL.actionSQL(i);
                worker.ReportProgress(++indexProgressbar);
                Thread.Sleep(100);  // 30
            }

        }  // updateAction




        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
            e.Cancel = false;
            Basis.writeWindowPosition2Registry(this, InstallRegistry.C_REG_ADR + "\\position", "dialog" + dbtable);
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            Close();
        }
    }
}