﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;


using System.IO;

namespace Install_SetWebVersion {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {

        const int WEB_BINARY_MODUL1 = 1;
        const int WEB_BINARY_MODUL2 = 2;
        const int WEB_BINARY_MODUL3 = 4;

        String filename = "version-mw-2018.bin";

        public MainWindow() {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            if (File.Exists(filename)) {
                byte zahl1, zahl2, zahl3;
                FileStream inFile = new FileStream(filename, FileMode.OpenOrCreate);
                BinaryReader inStream = new BinaryReader(inFile);
                zahl1 = inStream.ReadByte();
                zahl2 = inStream.ReadByte();
                zahl3 = inStream.ReadByte();
                inStream.Close();
                inFile.Close();
                tZahl1.Text = zahl1.ToString();
                tZahl2.Text = zahl2.ToString();
                tZahl3.Text = zahl3.ToString();
            }
            else {
                tZahl1.Text = "19";
                tZahl2.Text = "01";
                tZahl3.Text = "19";
            }
            tZahl1.Focus();
        }

        private void tTextBox_GotFocus(object sender, RoutedEventArgs e) {
            ((TextBox)sender).SelectAll();
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            byte zahl1, zahl2, zahl3;
            if (!byte.TryParse(tZahl1.Text, out zahl1)) {
                Basis.ErrorMsg("Fehlerhafte 1. Zahl", "Fehler");
                return;
            }
            if (zahl1 <= 0) {
                Basis.ErrorMsg("Fehlerhafte 1. Zahl", "Fehler");
                return;
            }

            if (!byte.TryParse(tZahl2.Text, out zahl2)) {
                Basis.ErrorMsg("Fehlerhafte 2. Zahl", "Fehler");
                return;
            }
            if (zahl2 <= 0) {
                Basis.ErrorMsg("Fehlerhafte 2. Zahl", "Fehler");
                return;
            }

            if (!byte.TryParse(tZahl3.Text, out zahl3)) {
                Basis.ErrorMsg("Fehlerhafte 3. Zahl", "Fehler");
                return;
            }
            if (zahl3 <= 0) {
                Basis.ErrorMsg("Fehlerhafte 3. Zahl", "Fehler");
                return;
            }


            byte value = 0;
            if (chkModul1.IsChecked == true) {
                value += WEB_BINARY_MODUL1;
            }
            if (chkModul2.IsChecked == true) {
                value += WEB_BINARY_MODUL2;
            }
            if (chkModul3.IsChecked == true) {
                value += WEB_BINARY_MODUL3;
            }

            FileStream oFile = new FileStream(filename, FileMode.Create);
            BinaryWriter oStream = new BinaryWriter(oFile);
            oStream.Write(zahl1);
            oStream.Write(zahl2);
            oStream.Write(zahl3);
            oStream.Write(value);
            oStream.Close();
            oFile.Close();


            Close();
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }


    }
}
