﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.ComponentModel;
using System.IO;
using System.Net;
using System.Diagnostics;
using System.Threading;

namespace Install_WebInstaller {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {

        private String dbtable = "Install_WebInstaller";

        private const String updateFile7z = "2018-Company-Update.7z";


        const int WEB_BINARY_MODUL1 = 1;
        const int WEB_BINARY_MODUL2 = 2;
        const int WEB_BINARY_MODUL3 = 4;


        private BackgroundWorker worker = null;
        private String _sourcepath = "";

        private byte[] webbytes;

        private bool allesAus = false;
        private String companystartProgramm = "";
        private String companystartProgrammdirectory = "";

        private bool canClose = true;
        private int indexProgressbar = 0;

        private bool modul1 = false;
        private bool modul2 = false;
        private bool modul3 = false;
        private bool abbruch = false;


        public MainWindow() {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            Title = Basis.getProgPath();

            String username = System.Environment.UserName;

            checkUpdate();
            Basis.setWindowPositionFromRegistry(this, InstallRegistry.C_REG_ADR + "\\position", "table" + dbtable);

            // hier wird das Main-Programm gesucht, da es später automatisch aufgerufen werden muss
            // es muss also in der Registry eingetragen sein
            companystartProgrammdirectory = Basis.ReadRegString(InstallRegistry.C_REG_ADR, "Programmdirectory");
            if (!companystartProgrammdirectory.EndsWith("\\")) {
                companystartProgrammdirectory += companystartProgrammdirectory + "\\";
            }
            companystartProgramm = companystartProgrammdirectory + InstallRegistry.C_MAINPROG;
            if (File.Exists(companystartProgramm)) {
                allesAus = false;
            }
            else {
                Basis.Message("Das Programm "+ InstallRegistry.C_MAINPROG+" ist nicht installiert", "Hinweis");
                bnOk.IsEnabled = false;
                allesAus = true;
            }
            _sourcepath = Basis.getProgPath();
        }  // Window_Loaded


        private void checkUpdate() {
            try {
                modul1 = false;
                modul2 = false;
                modul3 = false;
                String url = "http://www.miwilhelm.de/version-mw-2018.bin";
                byte b1 = (byte)Basis.ReadRegInt(InstallRegistry.C_REG_ADR, "Version1");
                byte b2 = (byte)Basis.ReadRegInt(InstallRegistry.C_REG_ADR, "Version2");
                byte b3 = (byte)Basis.ReadRegInt(InstallRegistry.C_REG_ADR, "Version3");

                labelProgressbar.Content = "Laden der Updateversion";

                try {
                    using (var client = new WebClient()) {
                        webbytes = client.DownloadData(url);    // 4 Bytes
                        FileStream oFile = new FileStream(Basis.getProgPath() + "webbytes.bin", FileMode.Create);
                        BinaryWriter oStream = new BinaryWriter(oFile);
                        oStream.Write(webbytes);
                        oStream.Close();
                        oFile.Close();

                        //int versionRegistry = (b1 * 1000 + b2) * 1000 + b3;
                        //int versionWeb = (webbytes[0] * 1000 + webbytes[1]) * 1000 + webbytes[2];
                        int versionRegistry = ((2000 + b1) * 100 + b2) * 100 + b3;
                        int versionWeb = ((2000 + webbytes[0]) * 100 + webbytes[1]) * 100 + webbytes[2];
                        int module = webbytes[3];
                        if ((module & WEB_BINARY_MODUL1) > 0) {
                            bnModul1.IsEnabled = true;
                            modul1 = true;
                        }
                        if ((module & WEB_BINARY_MODUL2) > 0) {
                            bnModul2.IsEnabled = true;
                            modul2 = true;
                        }
                        if ((module & WEB_BINARY_MODUL3) > 0) {
                            bnModul3.IsEnabled = true;
                            modul3 = true;
                        }

                        labelAktuelleVersion.Content = "Aktuelle Version: " + (2000 + b1) + "." + b2.ToString("00") + "." + b3.ToString("00");
                        labelNeueVersion.Content = "Neue Version: " + (2000 + webbytes[0]) + "." + webbytes[1].ToString("00") + "." + webbytes[2].ToString("00");
                        if (versionRegistry < versionWeb) {
                        }
                        else {
                            bnOk.IsEnabled = false;
                        }
                    }
                }
                catch (Exception) {
                    bnOk.IsEnabled = false;
                    Basis.Message("Es ist momentan kein Internet verfügbar!", "Hinweis");
                }
                labelProgressbar.Content = "";
            }
            catch (Exception e) {
                bnOk.IsEnabled = false;
                Basis.Message("Fehler beim Update-Check aus dem Internet\r\n" + e.ToString(), "Hinweis");
            }

        }  // checkUpdate


        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                e.Handled = true;
                if (bnOk.IsEnabled) {
                    bnOk_Click(sender, e);
                }

            }
            if (Keyboard.IsKeyDown(Key.Cancel)) {
                e.Handled = true;
                bnEsc_Click(sender, e);
            }

        }


        private void bnOk_Click(object sender, RoutedEventArgs e) {
            if (!Directory.Exists(_sourcepath)) {
                Basis.ErrorMsg("Das Quell-Verzeichnis existiert nicht\r\n" + _sourcepath, "Fehler");
                return;
            }

            Process[] ProgrammTask = null;
            try {
                ProgrammTask = Process.GetProcesses();
                foreach (Process scannTask in ProgrammTask) {
                    if (scannTask.ProcessName.Equals("Install_Main")) {
                        scannTask.Close();
                        Basis.Message("Das Programm "+ InstallRegistry.C_MAINPROG+" ist noch im Speicher.\r\nBitte erst das Programm "+ InstallRegistry.C_MAINPROG+" schließen", "Hinweis");
                    }
                }
            }
            catch (Exception) {
                Basis.ErrorMsg("Das Company-Main-Programm konnte nicht gelöscht werden", "Hinweis");
            }
            ProgrammTask = Process.GetProcesses();
            foreach (Process scannTask in ProgrammTask) {
                if (scannTask.ProcessName.Equals("Install_Main")) {
                    scannTask.Close();
                    Basis.Message("Das Company-Main-Programm ist immer noch im Speicher. Bitte erst das Company-Main schließen", "Hinweis");
                    return;
                }
            }


            if (!_sourcepath.EndsWith("\\")) {
                _sourcepath += "\\";
            }

            progressbar.Visibility = Visibility.Visible;
            progressbar.Maximum = 7;  // 4 + Anzahl der Module
            progressbar.Value = 0;
            indexProgressbar = 0;
            abbruch = false;

            labelProgressbar.Content = "Verbinden mit dem Web";
            worker = new BackgroundWorker();
            worker.WorkerReportsProgress = true;
            worker.DoWork += updateAction;
            worker.ProgressChanged += worker_ProgressChanged;
            worker.RunWorkerAsync();
            // laden des Updates
        }

        void worker_ProgressChanged(object sender, ProgressChangedEventArgs e) {
            progressbar.Value = e.ProgressPercentage;
            switch (e.ProgressPercentage) {
                case 1:
                    labelProgressbar.Content = "Verbinden mit dem Web";
                    break;
                case 2:
                    labelProgressbar.Content = "Dowload des Updates";
                    break;
                case 3:
                    labelProgressbar.Content = "Temporäres Speichern des Updates";
                    break;
                case 4:
                    labelProgressbar.Content = "Entzippen des Updates";
                    break;
                case 5:
                    labelProgressbar.Content = "Installieren des Plugins 'Modul1'";
                    break;
                case 6:
                    labelProgressbar.Content = "Installieren des Plugins 'Modul2'";
                    break;
                case 7:
                    labelProgressbar.Content = "Installieren des Plugins 'Modul3'";
                    break;
            }  // switch
            if (e.ProgressPercentage == progressbar.Maximum || abbruch) {
                progressbar.Value = 0;
                progressbar.Visibility = System.Windows.Visibility.Hidden;

                progressbar.Value = 0;
                if (abbruch) {
                    Basis.ErrorMsg("Das Update wurde NICHT erfolgreich installiert", "Fehler");
                }
                else {
                    Basis.Message("Das Update wurde erfolgreich installiert", "Hinweis");
                    // yyyyyyyyyyyyy
                    Basis.WriteRegInt(InstallRegistry.C_REG_ADR, "Version1", webbytes[0]);
                    Basis.WriteRegInt(InstallRegistry.C_REG_ADR, "Version2", webbytes[1]);
                    Basis.WriteRegInt(InstallRegistry.C_REG_ADR, "Version3", webbytes[2]);
                    Basis.WriteRegBool(InstallRegistry.C_REG_ADR, "setVersion2018", true);
                    Basis.WriteRegInt(InstallRegistry.C_REG_ADR, "Day", System.DateTime.Now.Day);
                    Basis.WriteRegInt(InstallRegistry.C_REG_ADR, "Month", System.DateTime.Now.Month);
                    Basis.WriteRegInt(InstallRegistry.C_REG_ADR, "Year", System.DateTime.Now.Year);

                    // nun das Main Install_Main Programm aufrufen
                    if (File.Exists(companystartProgramm)) {
                        Process Prog = new Process();
                        Prog.StartInfo.Arguments = "";
                        Prog.StartInfo.FileName = companystartProgramm;
                        Prog.Start();
                        //Prog.WaitForExit();
                        Prog.Close();
                    }
                    canClose = true;
                    Close();
                }
            }
        }


        // hier sind die Update Aktionen
        // natürlich unterschiedlich
        private void updateAction(object sender, DoWorkEventArgs e) {
            if (!loadUpdate()) {   // intern worker.ReportProgress(++indexProgressbar);
                abbruch = true;
                return;
            }

            // entzippen
            if (!entzippen()) {  // intern worker.ReportProgress(++indexProgressbar);
                abbruch = true;
                return;
            }

            if (modul1) {
                // kopiert nun die Dateien in das Verzeichnis des Hauptprogramms
                if (!copyFiles(Basis.getProgPath() + "Modul1\\", companystartProgrammdirectory)) {
                    abbruch = true;
                    return;
                }
            }
            worker.ReportProgress(++indexProgressbar);
            Thread.Sleep(10);  // 30

            if (modul2) {
                //if (!copyPlugin("Modul2\\")) {
                //    abbruch = true;
                //    return;
                //}
            }
            worker.ReportProgress(++indexProgressbar);
            Thread.Sleep(10);  // 30


            if (modul3) {
                //if (!copyPlugin("Modul3\\")) {
                //    abbruch = true;
                //    return;
                //}
            }
            worker.ReportProgress(++indexProgressbar);
            Thread.Sleep(10);  // 30

        }  // updateAction


        // hier wird die 7z-Datei geladen
        private bool loadUpdate() {
            worker.ReportProgress(++indexProgressbar);
            Thread.Sleep(10);  // 30
            String url = "http://www.miwilhelm.de/" + updateFile7z;
            try {
                using (var client = new WebClient()) {
                    worker.ReportProgress(++indexProgressbar);
                    Thread.Sleep(10);  // 30

                    byte[] updatesBytes = client.DownloadData(url);
                    worker.ReportProgress(++indexProgressbar);
                    Thread.Sleep(10);  // 30

                    FileStream oFile = new FileStream(Basis.getProgPath() + updateFile7z, FileMode.Create);
                    BinaryWriter oStream = new BinaryWriter(oFile);
                    oStream.Write(updatesBytes);
                    oStream.Close();
                    oFile.Close();
                    worker.ReportProgress(++indexProgressbar);
                    Thread.Sleep(10);  // 30
                }
            }
            catch (Exception e) {
                // Basis.Message("Kein Internet", "Hinweis");
                Basis.Message("Fehler beim Laden des Updates aus dem Internet\r\n" + e.ToString(), "Hinweis");
                return false;
            }
            return true;
        }  // loadUpdate


        private bool entzippen() {
            String[] dirs = { "Modul1", "Modul3", "Modul3" };
            try {
                // Update-Verzeichnisse löschen
                foreach (String dir in dirs) {
                    String path = Basis.getProgPath() + dir;
                    if (Directory.Exists(path)) {
                        Directory.Delete(path, true);
                    }
                }
                // Directory.CreateDirectory(path7z);
                Process Prog = new Process();
                Prog.StartInfo.FileName = Basis.getProgPath() + "7z\\7z.exe";
                Prog.StartInfo.Arguments = "x " + Basis.getProgPath() + updateFile7z + " -y -o" + Basis.getProgPath();
                // Basis.Message(Prog.StartInfo.Arguments, "Prog.StartInfo.Arguments");
                Prog.Start();
                Prog.WaitForExit();
                Prog.Close();
                worker.ReportProgress(++indexProgressbar);
                Thread.Sleep(10);  // 30
            }
            catch (Exception e) {
                // Basis.Message("Kein Internet", "Hinweis");
                Basis.Message("Fehler beim Entzippen des Updates aus dem Internet\r\n" + e.ToString(), "Hinweis");
                return false;
            }
            return true;
        }



        private bool copyFiles(String sourceDir, String destDir) {
            try {
                if (Directory.Exists(sourceDir)) {
                    String[] files = Directory.GetFiles(sourceDir);
                    String filename;
                    foreach (String file in files) {
                        filename = Basis.getFilename(file);
                        File.Copy(file, destDir + filename, true);
                    }
                }
            }
            catch (Exception ex) {
                Basis.ErrorMsg("Fehlerhafte Dateioperation\r\n" + ex, "Fehler");
                return false;
            }
            return true;
        }


        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_Closing(object sender, CancelEventArgs e) {
            if (canClose) {
                e.Cancel = false;
            }
            else {
                e.Cancel = true;
            }
            Basis.writeWindowPosition2Registry(this, InstallRegistry.C_REG_ADR + "\\position", "table" + dbtable);
        }

    }
}





